module fsm_rd_001 (RST, CLK, ptext, rtext);
//user interface
	input RST, CLK;
	input [1:0] ptext;
	output[7:0] rtext;
	reg [7:0] rtext;
//STATE ASSIGNMENTS
	`include "fsm_rd_001_stassign.v";
   //process modeling state register
   always @ (posedge RST or posedge CLK) begin
      if( RST == 1) begin
	 State <= st_st1;
      end
      else
	State <= NextState;
   end
   always @ (State or ptext) begin
      case ( State )
	  st_st1: begin
		if(ptext[0] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0 )
 		  NextState <= st_st20;
		rtext <= 'b11111111;
	  end
	  st_st2: begin
		if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[1] == 0 )
 		  NextState <= st_st2;
		rtext <= 'b00010011;
	  end
	  st_st3: begin
		if(ptext[0] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1 )
 		  NextState <= st_st4;
		rtext <= 'b11101111;
	  end
	  st_st4: begin
		if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[1] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st4;
		else if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st5;
		rtext <= 'b00001000;
	  end
	  st_st5: begin
		if(ptext[1] == 1 )
 		  NextState <= st_st4;
		else if(ptext[1] == 0 )
 		  NextState <= st_st6;
		rtext <= 'b00011011;
	  end
	  st_st6: begin
		if(ptext[1] == 0 )
 		  NextState <= st_st7;
		else if(ptext[1] == 1 )
 		  NextState <= st_st6;
		rtext <= 'b10111111;
	  end
	  st_st7: begin
		if(1)
 		  NextState <= st_st8;
		rtext <= 'b00100000;
	  end
	  st_st8: begin
		if(ptext[1] == 1 )
 		  NextState <= st_st7;
		else if(ptext[1] == 0 )
 		  NextState <= st_st9;
		rtext <= 'b11001111;
	  end
	  st_st9: begin
		if(ptext[0] == 1 )
 		  NextState <= st_st10;
		else if(ptext[0] == 0 )
 		  NextState <= st_st9;
		rtext <= 'b00111011;
	  end
	  st_st10: begin
		if(1)
 		  NextState <= st_st11;
		rtext <= 'b01001011;
	  end
	  st_st11: begin
		if(ptext[0] == 1 )
 		  NextState <= st_st10;
		else if(ptext[0] == 0 )
 		  NextState <= st_st12;
		rtext <= 'b11110011;
	  end
	  st_st12: begin
		if(1)
 		  NextState <= st_st13;
		rtext <= 'b00101000;
	  end
	  st_st13: begin
		if(1)
 		  NextState <= st_st14;
		rtext <= 'b11011111;
	  end
	  st_st14: begin
		if(ptext[1] == 1 )
 		  NextState <= st_st13;
		else if(ptext[1] == 0 )
 		  NextState <= st_st15;
		rtext <= 'b11100011;
	  end
	  st_st15: begin
		if(ptext[0] == 1 )
 		  NextState <= st_st16;
		else if(ptext[0] == 0 )
 		  NextState <= st_st15;
		rtext <= 'b11000011;
	  end
	  st_st16: begin
		if(ptext[1] == 0 )
 		  NextState <= st_st17;
		else if(ptext[1] == 1 )
 		  NextState <= st_st16;
		rtext <= 'b11010011;
	  end
	  st_st17: begin
		if(ptext[1] == 0 )
 		  NextState <= st_st18;
		else if(ptext[1] == 1 )
 		  NextState <= st_st17;
		rtext <= 'b01000011;
	  end
	  st_st18: begin
		if(ptext[0] == 1 )
 		  NextState <= st_st17;
		else if(ptext[0] == 0 )
 		  NextState <= st_st19;
		rtext <= 'b00110011;
	  end
	  st_st19: begin
		if(ptext[1] == 1 )
 		  NextState <= st_st20;
		else if(ptext[1] == 0 )
 		  NextState <= st_st19;
		rtext <= 'b10110011;
	  end
	  st_st20: begin
		if(1)
 		  NextState <= st_st1;
		rtext <= 'b10110011;
	  end
      endcase // case ( State )
   end // always @ (State or ptext)   
endmodule // fsm
