module fsm_rd_002 (RST, CLK, ptext, rtext);
//user interface
	input RST, CLK;
	input [3:0] ptext;
	output[3:0] rtext;
	reg [3:0] rtext;
//STATE ASSIGNMENTS
	`include "fsm_rd_002_stassign.v";
   //process modeling state register
   always @ (posedge RST or posedge CLK) begin
      if( RST == 1) begin
	 State <= st_st1;
      end
      else
	State <= NextState;
   end
   always @ (State or ptext) begin
      case ( State )
	  st_st1: begin
		if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st10;
		rtext <= 'bx1x1;
	  end
	  st_st2: begin
		if(ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st1;
		else if(ptext[2] == 1  && ptext[3] == 0 )
 		  NextState <= st_st3;
		else if(ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st2;
		else if(ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st3;
		rtext <= 'b000x;
	  end
	  st_st3: begin
		if(ptext[1] == 1  && ptext[3] == 0 )
 		  NextState <= st_st2;
		else if(ptext[1] == 0  && ptext[3] == 0 )
 		  NextState <= st_st4;
		else if(ptext[1] == 0  && ptext[3] == 1 )
 		  NextState <= st_st3;
		else if(ptext[1] == 1  && ptext[3] == 1 )
 		  NextState <= st_st4;
		rtext <= 'b0x11;
	  end
	  st_st4: begin
		if(1)
 		  NextState <= st_st5;
		rtext <= 'b1111;
	  end
	  st_st5: begin
		if(ptext[0] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1 )
 		  NextState <= st_st6;
		rtext <= 'b0110;
	  end
	  st_st6: begin
		if(ptext[1] == 0 )
 		  NextState <= st_st7;
		else if(ptext[1] == 1 )
 		  NextState <= st_st6;
		rtext <= 'b1110;
	  end
	  st_st7: begin
		if(ptext[3] == 1 )
 		  NextState <= st_st6;
		else if(ptext[3] == 0 )
 		  NextState <= st_st8;
		rtext <= 'b1111;
	  end
	  st_st8: begin
		if(ptext[1] == 0  && ptext[3] == 1 )
 		  NextState <= st_st7;
		else if(ptext[1] == 1 )
 		  NextState <= st_st9;
		else if(ptext[1] == 0  && ptext[3] == 0 )
 		  NextState <= st_st8;
		rtext <= 'b01x0;
	  end
	  st_st9: begin
		if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st8;
		else if(ptext[0] == 1  && ptext[1] == 0 )
 		  NextState <= st_st10;
		else if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st10;
		rtext <= 'b1100;
	  end
	  st_st10: begin
		if(ptext[1] == 1 )
 		  NextState <= st_st9;
		else if(ptext[1] == 0 )
 		  NextState <= st_st1;
		rtext <= 'b1001;
	  end
      endcase // case ( State )
   end // always @ (State or ptext)   
endmodule // fsm
