module fsm_rd_007 (RST, CLK, ptext, rtext);
//user interface
	input RST, CLK;
	input [7:0] ptext;
	output[11:0] rtext;
	reg [11:0] rtext;
//STATE ASSIGNMENTS
	`include "fsm_rd_007_stassign.v";
   //process modeling state register
   always @ (posedge RST or posedge CLK) begin
      if( RST == 1) begin
	 State <= st_st1;
      end
      else
	State <= NextState;
   end
   always @ (State or ptext) begin
      case ( State )
	  st_st1: begin
		if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[7] == 0 )
 		  NextState <= st_st2;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[7] == 1 )
 		  NextState <= st_st4;
		else if(ptext[1] == 1  && ptext[2] == 0 )
 		  NextState <= st_st2;
		else if(ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[2] == 0 )
 		  NextState <= st_st4;
		rtext <= 'b111100001011;
	  end
	  st_st2: begin
		if(ptext[0] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[7] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[4] == 1  && ptext[7] == 0 )
 		  NextState <= st_st2;
		else if(ptext[2] == 0  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[4] == 0  && ptext[7] == 0 )
 		  NextState <= st_st3;
		else if(ptext[2] == 1  && ptext[7] == 1 )
 		  NextState <= st_st2;
		rtext <= 'b101011111101;
	  end
	  st_st3: begin
		if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[3] == 0 )
 		  NextState <= st_st3;
		else if(ptext[3] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[3] == 0 )
 		  NextState <= st_st3;
		rtext <= 'b110111111111;
	  end
	  st_st4: begin
		if(ptext[0] == 0  && ptext[3] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1  && ptext[7] == 0 )
 		  NextState <= st_st4;
		else if(ptext[7] == 1 )
 		  NextState <= st_st5;
		else if(ptext[3] == 1  && ptext[7] == 0 )
 		  NextState <= st_st4;
		rtext <= 'b011111000111;
	  end
	  st_st5: begin
		if(ptext[4] == 1  && ptext[7] == 1 )
 		  NextState <= st_st4;
		else if(ptext[1] == 0  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1 )
 		  NextState <= st_st4;
		else if(ptext[1] == 0  && ptext[4] == 0 )
 		  NextState <= st_st1;
		rtext <= 'b011111000111;
	  end
      endcase // case ( State )
   end // always @ (State or ptext)   
endmodule // fsm
