module fsm_rd_012 (RST, CLK, ptext, rtext);
//user interface
	input RST, CLK;
	input [7:0] ptext;
	output[7:0] rtext;
	reg [7:0] rtext;
//STATE ASSIGNMENTS
	`include "fsm_rd_012_stassign.v";
   //process modeling state register
   always @ (posedge RST or posedge CLK) begin
      if( RST == 1) begin
	 State <= st_st1;
      end
      else
	State <= NextState;
   end
   always @ (State or ptext) begin
      case ( State )
	  st_st1: begin
		if(1)
 		  NextState <= st_st2;
		rtext <= 'b11100001;
	  end
	  st_st2: begin
		if(1)
 		  NextState <= st_st3;
		rtext <= 'b11101101;
	  end
	  st_st3: begin
		if(ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st4;
		else if(ptext[1] == 1  && ptext[6] == 0 )
 		  NextState <= st_st3;
		else if(ptext[1] == 0 )
 		  NextState <= st_st4;
		else if(ptext[1] == 1  && ptext[5] == 1 )
 		  NextState <= st_st3;
		rtext <= 'b1xxx1001;
	  end
	  st_st4: begin
		if(1)
 		  NextState <= st_st5;
		rtext <= 'b01111xx1;
	  end
	  st_st5: begin
		if(ptext[0] == 0  && ptext[2] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[6] == 0 )
 		  NextState <= st_st6;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[5] == 1 )
 		  NextState <= st_st5;
		else if(ptext[0] == 0  && ptext[6] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[5] == 0 )
 		  NextState <= st_st6;
		else if(ptext[2] == 1  && ptext[6] == 1 )
 		  NextState <= st_st5;
		rtext <= 'b01111110;
	  end
	  st_st6: begin
		if(1)
 		  NextState <= st_st7;
		rtext <= 'b0x11xx1x;
	  end
	  st_st7: begin
		if(1)
 		  NextState <= st_st1;
		rtext <= 'b0x11xx1x;
	  end
      endcase // case ( State )
   end // always @ (State or ptext)   
endmodule // fsm
