module fsm_rd_017 (RST, CLK, ptext, rtext);
//user interface
	input RST, CLK;
	input [7:0] ptext;
	output[11:0] rtext;
	reg [11:0] rtext;
//STATE ASSIGNMENTS
	`include "fsm_rd_017_stassign.v";
   //process modeling state register
   always @ (posedge RST or posedge CLK) begin
      if( RST == 1) begin
	 State <= st_st1;
      end
      else
	State <= NextState;
   end
   always @ (State or ptext) begin
      case ( State )
	  st_st1: begin
		if(ptext[1] == 1  && ptext[2] == 0 )
 		  NextState <= st_st2;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0 )
 		  NextState <= st_st8;
		else if(ptext[2] == 0  && ptext[7] == 0 )
 		  NextState <= st_st2;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[7] == 1 )
 		  NextState <= st_st8;
		rtext <= 'b111101011111;
	  end
	  st_st2: begin
		if(ptext[0] == 1  && ptext[2] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[4] == 1 )
 		  NextState <= st_st3;
		else if(ptext[4] == 0 )
 		  NextState <= st_st1;
		else if(ptext[2] == 0  && ptext[4] == 1 )
 		  NextState <= st_st3;
		rtext <= 'b001011011100;
	  end
	  st_st3: begin
		if(1)
 		  NextState <= st_st4;
		rtext <= 'b111110110101;
	  end
	  st_st4: begin
		if(ptext[1] == 0  && ptext[4] == 1 )
 		  NextState <= st_st5;
		else if(ptext[4] == 0  && ptext[7] == 1 )
 		  NextState <= st_st4;
		else if(ptext[7] == 0 )
 		  NextState <= st_st5;
		else if(ptext[1] == 1  && ptext[7] == 1 )
 		  NextState <= st_st4;
		rtext <= 'b110101101101;
	  end
	  st_st5: begin
		if(ptext[2] == 1  && ptext[5] == 0 )
 		  NextState <= st_st4;
		else if(ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st6;
		else if(ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st5;
		else if(ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st4;
		else if(ptext[2] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st6;
		else if(ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st5;
		rtext <= 'b011101010101;
	  end
	  st_st6: begin
		if(ptext[0] == 1  && ptext[4] == 0 )
 		  NextState <= st_st7;
		else if(ptext[0] == 0  && ptext[2] == 1 )
 		  NextState <= st_st6;
		else if(ptext[2] == 0 )
 		  NextState <= st_st7;
		else if(ptext[2] == 1  && ptext[4] == 1 )
 		  NextState <= st_st6;
		rtext <= 'b001011101001;
	  end
	  st_st7: begin
		if(1)
 		  NextState <= st_st1;
		rtext <= 'b111100100000;
	  end
	  st_st8: begin
		if(ptext[0] == 0  && ptext[3] == 1 )
 		  NextState <= st_st9;
		else if(ptext[3] == 0  && ptext[7] == 0 )
 		  NextState <= st_st8;
		else if(ptext[7] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[7] == 0 )
 		  NextState <= st_st8;
		rtext <= 'b110011110000;
	  end
	  st_st9: begin
		if(ptext[1] == 1  && ptext[6] == 0 )
 		  NextState <= st_st8;
		else if(ptext[1] == 0  && ptext[5] == 1 )
 		  NextState <= st_st10;
		else if(ptext[5] == 0 )
 		  NextState <= st_st8;
		else if(ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st10;
		rtext <= 'b000111101111;
	  end
	  st_st10: begin
		if(1)
 		  NextState <= st_st11;
		rtext <= 'b010101110111;
	  end
	  st_st11: begin
		if(ptext[4] == 0  && ptext[7] == 0 )
 		  NextState <= st_st10;
		else if(ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st12;
		else if(ptext[6] == 0 )
 		  NextState <= st_st10;
		else if(ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st12;
		rtext <= 'b110000111111;
	  end
	  st_st12: begin
		if(ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st11;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st13;
		else if(ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st12;
		else if(ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st11;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st13;
		else if(ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st13;
		else if(ptext[2] == 1  && ptext[5] == 0 )
 		  NextState <= st_st12;
		rtext <= 'b110100110111;
	  end
	  st_st13: begin
		if(ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st1;
		else if(ptext[3] == 1  && ptext[7] == 1 )
 		  NextState <= st_st13;
		else if(ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[4] == 1  && ptext[7] == 1 )
 		  NextState <= st_st13;
		rtext <= 'b110100110111;
	  end
      endcase // case ( State )
   end // always @ (State or ptext)   
endmodule // fsm
