module fsm_rd_041 (RST, CLK, ptext, rtext);
//user interface
	input RST, CLK;
	input [1:0] ptext;
	output[5:0] rtext;
	reg [5:0] rtext;
//STATE ASSIGNMENTS
	`include "fsm_rd_041_stassign.v";
   //process modeling state register
   always @ (posedge RST or posedge CLK) begin
      if( RST == 1) begin
	 State <= st_st1;
      end
      else
	State <= NextState;
   end
   always @ (State or ptext) begin
      case ( State )
	  st_st1: begin
		if(ptext[0] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0 )
 		  NextState <= st_st1;
		rtext <= 'b000101;
	  end
	  st_st2: begin
		if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st2;
		rtext <= 'b011000;
	  end
	  st_st3: begin
		if(ptext[0] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1 )
 		  NextState <= st_st4;
		rtext <= 'b100100;
	  end
	  st_st4: begin
		if(ptext[0] == 1 )
 		  NextState <= st_st5;
		else if(ptext[0] == 0 )
 		  NextState <= st_st4;
		rtext <= 'b111110;
	  end
	  st_st5: begin
		if(1)
 		  NextState <= st_st6;
		rtext <= 'b010000;
	  end
	  st_st6: begin
		if(ptext[1] == 0 )
 		  NextState <= st_st7;
		else if(ptext[1] == 1 )
 		  NextState <= st_st6;
		rtext <= 'b111000;
	  end
	  st_st7: begin
		if(ptext[1] == 0 )
 		  NextState <= st_st8;
		else if(ptext[1] == 1 )
 		  NextState <= st_st7;
		rtext <= 'b001011;
	  end
	  st_st8: begin
		if(ptext[0] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1 )
 		  NextState <= st_st8;
		rtext <= 'b011100;
	  end
	  st_st9: begin
		if(ptext[1] == 0 )
 		  NextState <= st_st10;
		else if(ptext[1] == 1 )
 		  NextState <= st_st9;
		rtext <= 'b111101;
	  end
	  st_st10: begin
		if(ptext[1] == 1 )
 		  NextState <= st_st9;
		else if(ptext[1] == 0 )
 		  NextState <= st_st11;
		rtext <= 'b001000;
	  end
	  st_st11: begin
		if(ptext[1] == 1 )
 		  NextState <= st_st12;
		else if(ptext[1] == 0 )
 		  NextState <= st_st11;
		rtext <= 'b001001;
	  end
	  st_st12: begin
		if(1)
 		  NextState <= st_st13;
		rtext <= 'b010111;
	  end
	  st_st13: begin
		if(ptext[0] == 0 )
 		  NextState <= st_st14;
		else if(ptext[0] == 1 )
 		  NextState <= st_st13;
		rtext <= 'b001001;
	  end
	  st_st14: begin
		if(1)
 		  NextState <= st_st15;
		rtext <= 'b001101;
	  end
	  st_st15: begin
		if(1)
 		  NextState <= st_st16;
		rtext <= 'b001000;
	  end
	  st_st16: begin
		if(1)
 		  NextState <= st_st17;
		rtext <= 'b100000;
	  end
	  st_st17: begin
		if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st16;
		else if(ptext[0] == 0 )
 		  NextState <= st_st18;
		else if(ptext[0] == 1  && ptext[1] == 0 )
 		  NextState <= st_st17;
		rtext <= 'b010110;
	  end
	  st_st18: begin
		if(ptext[0] == 1  && ptext[1] == 0 )
 		  NextState <= st_st17;
		else if(ptext[1] == 1 )
 		  NextState <= st_st19;
		else if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st18;
		rtext <= 'b011010;
	  end
	  st_st19: begin
		if(ptext[1] == 1 )
 		  NextState <= st_st20;
		else if(ptext[1] == 0 )
 		  NextState <= st_st19;
		rtext <= 'b001101;
	  end
	  st_st20: begin
		if(ptext[1] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0 )
 		  NextState <= st_st20;
		rtext <= 'b001111;
	  end
      endcase // case ( State )
   end // always @ (State or ptext)   
endmodule // fsm
