module fsm_rd_046 (RST, CLK, ptext, rtext);
//user interface
	input RST, CLK;
	input [4:0] ptext;
	output[7:0] rtext;
	reg [7:0] rtext;
//STATE ASSIGNMENTS
	`include "fsm_rd_046_stassign.v";
   //process modeling state register
   always @ (posedge RST or posedge CLK) begin
      if( RST == 1) begin
	 State <= st_st1;
      end
      else
	State <= NextState;
   end
   always @ (State or ptext) begin
      case ( State )
	  st_st1: begin
		if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st6;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st8;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st10;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st10;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st10;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st13;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st15;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st16;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st16;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st24;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st4;
		rtext <= 'b01000111;
	  end
	  st_st2: begin
		if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st2;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st5;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st7;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 0  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st1;
		rtext <= 'b00101110;
	  end
	  st_st3: begin
		if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st3;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[3] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st4;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1 )
 		  NextState <= st_st4;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st3;
		else if(ptext[1] == 1  && ptext[4] == 0 )
 		  NextState <= st_st3;
		rtext <= 'b00100010;
	  end
	  st_st4: begin
		if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st7;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st7;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st4;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st16;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st18;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st18;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st7;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st7;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st4;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st7;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st7;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st4;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st16;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st18;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st18;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st7;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st7;
		rtext <= 'b10001001;
	  end
	  st_st5: begin
		if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st5;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st1;
		else if(ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0 )
 		  NextState <= st_st2;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st2;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st5;
		else if(ptext[1] == 1  && ptext[2] == 1 )
 		  NextState <= st_st5;
		rtext <= 'b00001011;
	  end
	  st_st6: begin
		if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st7;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st6;
		else if(ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st7;
		else if(ptext[1] == 1  && ptext[2] == 1 )
 		  NextState <= st_st7;
		else if(ptext[1] == 0  && ptext[2] == 1 )
 		  NextState <= st_st6;
		rtext <= 'b00011110;
	  end
	  st_st7: begin
		if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st6;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st7;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st4;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st10;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 1 )
 		  NextState <= st_st4;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st4;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st19;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 1 )
 		  NextState <= st_st7;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st4;
		rtext <= 'b10011010;
	  end
	  st_st8: begin
		if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0 )
 		  NextState <= st_st8;
		else if(ptext[1] == 1  && ptext[4] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[4] == 0 )
 		  NextState <= st_st9;
		else if(ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st9;
		else if(ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st8;
		rtext <= 'b00000101;
	  end
	  st_st9: begin
		if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 0 )
 		  NextState <= st_st8;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st2;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1 )
 		  NextState <= st_st8;
		else if(ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st8;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[3] == 1 )
 		  NextState <= st_st9;
		rtext <= 'b00000100;
	  end
	  st_st10: begin
		if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st7;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[2] == 0 )
 		  NextState <= st_st15;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st11;
		else if(ptext[1] == 0  && ptext[2] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[2] == 1 )
 		  NextState <= st_st15;
		rtext <= 'b01101111;
	  end
	  st_st11: begin
		if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st4;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[4] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st4;
		else if(ptext[2] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st11;
		else if(ptext[1] == 0  && ptext[2] == 1 )
 		  NextState <= st_st11;
		rtext <= 'b01110110;
	  end
	  st_st12: begin
		if(ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st7;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st12;
		else if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st7;
		else if(ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st4;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0 )
 		  NextState <= st_st4;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st12;
		else if(ptext[1] == 0  && ptext[4] == 0 )
 		  NextState <= st_st12;
		rtext <= 'b00100110;
	  end
	  st_st13: begin
		if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st14;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st13;
		else if(ptext[1] == 0  && ptext[4] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 1 )
 		  NextState <= st_st14;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1 )
 		  NextState <= st_st14;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0 )
 		  NextState <= st_st13;
		else if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st13;
		rtext <= 'b10000010;
	  end
	  st_st14: begin
		if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0 )
 		  NextState <= st_st10;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 1 )
 		  NextState <= st_st14;
		else if(ptext[0] == 0  && ptext[3] == 0 )
 		  NextState <= st_st10;
		else if(ptext[4] == 0 )
 		  NextState <= st_st10;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[4] == 1 )
 		  NextState <= st_st14;
		else if(ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st14;
		rtext <= 'b11101111;
	  end
	  st_st15: begin
		if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1 )
 		  NextState <= st_st10;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0 )
 		  NextState <= st_st15;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[4] == 0 )
 		  NextState <= st_st10;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st10;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st15;
		else if(ptext[2] == 0  && ptext[4] == 1 )
 		  NextState <= st_st15;
		rtext <= 'b00110011;
	  end
	  st_st16: begin
		if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st17;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 0 )
 		  NextState <= st_st16;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st1;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 1 )
 		  NextState <= st_st22;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 1 )
 		  NextState <= st_st24;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st17;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st16;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1 )
 		  NextState <= st_st1;
		rtext <= 'b00000011;
	  end
	  st_st17: begin
		if(ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st4;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1 )
 		  NextState <= st_st17;
		else if(ptext[0] == 1  && ptext[4] == 1 )
 		  NextState <= st_st4;
		else if(ptext[2] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st17;
		else if(ptext[2] == 1  && ptext[4] == 0 )
 		  NextState <= st_st17;
		rtext <= 'b10001010;
	  end
	  st_st18: begin
		if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1 )
 		  NextState <= st_st4;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 1 )
 		  NextState <= st_st18;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st4;
		else if(ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 0  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st4;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st4;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st18;
		else if(ptext[0] == 1  && ptext[3] == 1 )
 		  NextState <= st_st18;
		rtext <= 'b01010101;
	  end
	  st_st19: begin
		if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st7;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[4] == 1 )
 		  NextState <= st_st20;
		else if(ptext[0] == 0  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st19;
		else if(ptext[0] == 1  && ptext[2] == 0 )
 		  NextState <= st_st7;
		else if(ptext[0] == 0  && ptext[3] == 1 )
 		  NextState <= st_st20;
		else if(ptext[0] == 1  && ptext[2] == 1 )
 		  NextState <= st_st19;
		rtext <= 'b11100001;
	  end
	  st_st20: begin
		if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 0 )
 		  NextState <= st_st4;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st20;
		else if(ptext[1] == 0  && ptext[3] == 0 )
 		  NextState <= st_st4;
		else if(ptext[2] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st20;
		else if(ptext[1] == 1  && ptext[2] == 1 )
 		  NextState <= st_st20;
		rtext <= 'b11000001;
	  end
	  st_st21: begin
		if(ptext[0] == 0  && ptext[2] == 1  && ptext[4] == 1 )
 		  NextState <= st_st7;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st4;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st21;
		else if(ptext[1] == 1  && ptext[3] == 0 )
 		  NextState <= st_st7;
		else if(ptext[0] == 0  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st4;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st4;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[3] == 1 )
 		  NextState <= st_st21;
		rtext <= 'b01000010;
	  end
	  st_st22: begin
		if(ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st16;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st23;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[4] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st16;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st23;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 1 )
 		  NextState <= st_st23;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0 )
 		  NextState <= st_st22;
		else if(ptext[1] == 0  && ptext[3] == 1 )
 		  NextState <= st_st22;
		rtext <= 'b01001001;
	  end
	  st_st23: begin
		if(ptext[0] == 1  && ptext[2] == 1  && ptext[4] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st23;
		else if(ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 0 )
 		  NextState <= st_st23;
		else if(ptext[1] == 0  && ptext[4] == 1 )
 		  NextState <= st_st23;
		rtext <= 'b00000100;
	  end
	  st_st24: begin
		if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st16;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st24;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 1 )
 		  NextState <= st_st16;
		else if(ptext[0] == 1  && ptext[4] == 0 )
 		  NextState <= st_st16;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[4] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[4] == 1 )
 		  NextState <= st_st24;
		else if(ptext[2] == 0  && ptext[4] == 1 )
 		  NextState <= st_st24;
		rtext <= 'b11000111;
	  end
      endcase // case ( State )
   end // always @ (State or ptext)   
endmodule // fsm
