module fsm_rd_056 (RST, CLK, ptext, rtext);
//user interface
	input RST, CLK;
	input [1:0] ptext;
	output[8:0] rtext;
	reg [8:0] rtext;
//STATE ASSIGNMENTS
	`include "fsm_rd_056_stassign.v";
   //process modeling state register
   always @ (posedge RST or posedge CLK) begin
      if( RST == 1) begin
	 State <= st_st1;
      end
      else
	State <= NextState;
   end
   always @ (State or ptext) begin
      case ( State )
	  st_st1: begin
		if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st2;
		else if(ptext[1] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st8;
		rtext <= 'b001000010;
	  end
	  st_st2: begin
		if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st15;
		rtext <= 'b111001111;
	  end
	  st_st3: begin
		if(1)
 		  NextState <= st_st4;
		rtext <= 'b110001111;
	  end
	  st_st4: begin
		if(1)
 		  NextState <= st_st5;
		rtext <= 'b100001101;
	  end
	  st_st5: begin
		if(ptext[0] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1 )
 		  NextState <= st_st6;
		rtext <= 'b000101101;
	  end
	  st_st6: begin
		if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1  && ptext[1] == 0 )
 		  NextState <= st_st7;
		else if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st6;
		else if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st14;
		rtext <= 'b010101111;
	  end
	  st_st7: begin
		if(ptext[1] == 0 )
 		  NextState <= st_st6;
		else if(ptext[1] == 1 )
 		  NextState <= st_st8;
		rtext <= 'b110111111;
	  end
	  st_st8: begin
		if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0 )
 		  NextState <= st_st8;
		else if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st9;
		rtext <= 'b001101111;
	  end
	  st_st9: begin
		if(1)
 		  NextState <= st_st10;
		rtext <= 'b011000010;
	  end
	  st_st10: begin
		if(1)
 		  NextState <= st_st11;
		rtext <= 'b111111111;
	  end
	  st_st11: begin
		if(ptext[1] == 1 )
 		  NextState <= st_st10;
		else if(ptext[1] == 0 )
 		  NextState <= st_st12;
		rtext <= 'b101111111;
	  end
	  st_st12: begin
		if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0 )
 		  NextState <= st_st13;
		else if(ptext[0] == 1  && ptext[1] == 0 )
 		  NextState <= st_st12;
		rtext <= 'b100111101;
	  end
	  st_st13: begin
		if(ptext[0] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 1 )
 		  NextState <= st_st7;
		rtext <= 'b101001111;
	  end
	  st_st14: begin
		if(1)
 		  NextState <= st_st15;
		rtext <= 'b010000010;
	  end
	  st_st15: begin
		if(1)
 		  NextState <= st_st2;
		rtext <= 'b010000010;
	  end
      endcase // case ( State )
   end // always @ (State or ptext)   
endmodule // fsm
