module fsm_rd_060 (RST, CLK, ptext, rtext);
//user interface
	input RST, CLK;
	input [7:0] ptext;
	output[7:0] rtext;
	reg [7:0] rtext;
//STATE ASSIGNMENTS
	`include "fsm_rd_060_stassign.v";
   //process modeling state register
   always @ (posedge RST or posedge CLK) begin
      if( RST == 1) begin
	 State <= st_st1;
      end
      else
	State <= NextState;
   end
   always @ (State or ptext) begin
      case ( State )
	  st_st1: begin
		if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st3;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st4;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st6;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st7;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st8;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 1  && ptext[7] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st10;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st13;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st14;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st15;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st7;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st17;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st12;
		else if(ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st19;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st21;
		else if(ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st23;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st25;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st12;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st27;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st12;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 0 )
 		  NextState <= st_st29;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 1 )
 		  NextState <= st_st31;
		else if(ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st33;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st34;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st35;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st36;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st37;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st2;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st3;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st4;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st5;
		else if(ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st6;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st7;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st8;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st10;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 0 )
 		  NextState <= st_st13;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st14;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st15;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st7;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st17;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st19;
		else if(ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st21;
		rtext <= 'b00001000;
	  end
	  st_st2: begin
		if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[4] == 0  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st3;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st3;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[4] == 0  && ptext[7] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st2;
		else if(ptext[1] == 1  && ptext[4] == 1  && ptext[7] == 1 )
 		  NextState <= st_st2;
		else if(ptext[2] == 1  && ptext[4] == 1 )
 		  NextState <= st_st2;
		rtext <= 'b00000010;
	  end
	  st_st3: begin
		if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st3;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st2;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st2;
		else if(ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st2;
		else if(ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st2;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st3;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 1 )
 		  NextState <= st_st3;
		else if(ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st3;
		else if(ptext[1] == 0  && ptext[4] == 1  && ptext[7] == 1 )
 		  NextState <= st_st3;
		else if(ptext[3] == 1  && ptext[7] == 1 )
 		  NextState <= st_st3;
		rtext <= 'b00100000;
	  end
	  st_st4: begin
		if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st4;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st1;
		else if(ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st1;
		else if(ptext[2] == 0  && ptext[5] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st5;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st5;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st5;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st5;
		else if(ptext[2] == 1  && ptext[5] == 0  && ptext[7] == 0 )
 		  NextState <= st_st5;
		else if(ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st4;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st4;
		else if(ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 1 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st4;
		else if(ptext[1] == 0  && ptext[5] == 1 )
 		  NextState <= st_st4;
		rtext <= 'b00000100;
	  end
	  st_st5: begin
		if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st4;
		else if(ptext[1] == 0  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st4;
		else if(ptext[2] == 0  && ptext[4] == 0 )
 		  NextState <= st_st4;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st1;
		else if(ptext[2] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st5;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[6] == 0 )
 		  NextState <= st_st5;
		else if(ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st5;
		else if(ptext[2] == 1  && ptext[7] == 1 )
 		  NextState <= st_st5;
		rtext <= 'b01001000;
	  end
	  st_st6: begin
		if(ptext[0] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st7;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[7] == 0 )
 		  NextState <= st_st6;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[4] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st7;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st7;
		else if(ptext[1] == 1  && ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st7;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 1 )
 		  NextState <= st_st7;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st6;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1 )
 		  NextState <= st_st6;
		else if(ptext[1] == 0  && ptext[4] == 0  && ptext[7] == 0 )
 		  NextState <= st_st6;
		else if(ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st6;
		rtext <= 'b01000001;
	  end
	  st_st7: begin
		if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[7] == 0 )
 		  NextState <= st_st6;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st7;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st16;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st57;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st6;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st6;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st6;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st7;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[7] == 1 )
 		  NextState <= st_st7;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st7;
		else if(ptext[3] == 0  && ptext[5] == 0  && ptext[7] == 1 )
 		  NextState <= st_st7;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[3] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st16;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st16;
		else if(ptext[1] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st16;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[7] == 1 )
 		  NextState <= st_st16;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[7] == 1 )
 		  NextState <= st_st57;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[7] == 0 )
 		  NextState <= st_st57;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st57;
		rtext <= 'b10100010;
	  end
	  st_st8: begin
		if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[7] == 1 )
 		  NextState <= st_st8;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 1 )
 		  NextState <= st_st1;
		else if(ptext[2] == 1  && ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0 )
 		  NextState <= st_st9;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[6] == 0 )
 		  NextState <= st_st9;
		else if(ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st8;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st8;
		else if(ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st8;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[6] == 1 )
 		  NextState <= st_st8;
		else if(ptext[0] == 0  && ptext[6] == 1 )
 		  NextState <= st_st8;
		rtext <= 'b00000011;
	  end
	  st_st9: begin
		if(ptext[0] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st8;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st9;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st8;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[7] == 0 )
 		  NextState <= st_st8;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st8;
		else if(ptext[3] == 1  && ptext[7] == 0 )
 		  NextState <= st_st8;
		else if(ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[4] == 0  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[7] == 0 )
 		  NextState <= st_st9;
		else if(ptext[1] == 1  && ptext[3] == 1  && ptext[7] == 1 )
 		  NextState <= st_st9;
		else if(ptext[4] == 1  && ptext[7] == 1 )
 		  NextState <= st_st9;
		rtext <= 'b00000010;
	  end
	  st_st10: begin
		if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[7] == 0 )
 		  NextState <= st_st10;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[4] == 1  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[7] == 1 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st11;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st11;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st11;
		else if(ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st11;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st10;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st10;
		else if(ptext[2] == 0  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st10;
		else if(ptext[1] == 0  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st10;
		else if(ptext[2] == 0  && ptext[4] == 0 )
 		  NextState <= st_st10;
		rtext <= 'b10100111;
	  end
	  st_st11: begin
		if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st10;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st11;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st10;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 1 )
 		  NextState <= st_st10;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[7] == 1 )
 		  NextState <= st_st10;
		else if(ptext[0] == 0  && ptext[6] == 1 )
 		  NextState <= st_st10;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[6] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[6] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[7] == 0 )
 		  NextState <= st_st11;
		else if(ptext[2] == 0  && ptext[6] == 0 )
 		  NextState <= st_st11;
		rtext <= 'b00100001;
	  end
	  st_st12: begin
		if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st13;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st12;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st18;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[7] == 0 )
 		  NextState <= st_st20;
		else if(ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st24;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st26;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st28;
		else if(ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st30;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st32;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st34;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st35;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st36;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st37;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 1  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st13;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st13;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 0  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 0  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st18;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st18;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st20;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st20;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st22;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st24;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st24;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 1  && ptext[5] == 0  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 0 )
 		  NextState <= st_st26;
		else if(ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 0 )
 		  NextState <= st_st26;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st28;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[7] == 0 )
 		  NextState <= st_st28;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st30;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st30;
		else if(ptext[0] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st32;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st32;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st34;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st35;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st36;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st37;
		rtext <= 'b00110000;
	  end
	  st_st13: begin
		if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st13;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st12;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[7] == 1 )
 		  NextState <= st_st12;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st12;
		else if(ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st12;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 0  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st13;
		else if(ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st13;
		else if(ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 1 )
 		  NextState <= st_st13;
		else if(ptext[0] == 0  && ptext[7] == 0 )
 		  NextState <= st_st13;
		rtext <= 'b00100000;
	  end
	  st_st14: begin
		if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st15;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st14;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 0 )
 		  NextState <= st_st15;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st15;
		else if(ptext[0] == 0  && ptext[4] == 0  && ptext[7] == 0 )
 		  NextState <= st_st15;
		else if(ptext[1] == 1  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st15;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st14;
		else if(ptext[1] == 0  && ptext[3] == 1  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st14;
		else if(ptext[0] == 1  && ptext[5] == 0  && ptext[7] == 0 )
 		  NextState <= st_st14;
		else if(ptext[4] == 1  && ptext[7] == 0 )
 		  NextState <= st_st14;
		rtext <= 'b00001001;
	  end
	  st_st15: begin
		if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st14;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st15;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st14;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[7] == 0 )
 		  NextState <= st_st14;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[5] == 1  && ptext[7] == 0 )
 		  NextState <= st_st14;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[7] == 1 )
 		  NextState <= st_st14;
		else if(ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st14;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[3] == 1  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st15;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st15;
		else if(ptext[2] == 0  && ptext[3] == 0  && ptext[7] == 1 )
 		  NextState <= st_st15;
		else if(ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st15;
		else if(ptext[2] == 0  && ptext[6] == 1 )
 		  NextState <= st_st15;
		rtext <= 'b00000000;
	  end
	  st_st16: begin
		if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 1 )
 		  NextState <= st_st7;
		else if(ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st17;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st16;
		else if(ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st7;
		else if(ptext[3] == 0  && ptext[5] == 0 )
 		  NextState <= st_st7;
		else if(ptext[0] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st17;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 0 )
 		  NextState <= st_st17;
		else if(ptext[1] == 0  && ptext[5] == 1 )
 		  NextState <= st_st17;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st16;
		else if(ptext[1] == 1  && ptext[5] == 1 )
 		  NextState <= st_st16;
		rtext <= 'b00101010;
	  end
	  st_st17: begin
		if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st16;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st17;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st16;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[7] == 1 )
 		  NextState <= st_st16;
		else if(ptext[0] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st16;
		else if(ptext[2] == 1  && ptext[6] == 1 )
 		  NextState <= st_st16;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st17;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st17;
		else if(ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st17;
		else if(ptext[0] == 1  && ptext[2] == 0 )
 		  NextState <= st_st17;
		rtext <= 'b00101110;
	  end
	  st_st18: begin
		if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st19;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st18;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st38;
		else if(ptext[1] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st12;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[7] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[7] == 0 )
 		  NextState <= st_st19;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st19;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[5] == 0  && ptext[7] == 0 )
 		  NextState <= st_st19;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[5] == 1  && ptext[7] == 0 )
 		  NextState <= st_st18;
		else if(ptext[1] == 1  && ptext[7] == 1 )
 		  NextState <= st_st18;
		else if(ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st18;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1  && ptext[7] == 0 )
 		  NextState <= st_st38;
		else if(ptext[1] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st38;
		else if(ptext[1] == 1  && ptext[7] == 0 )
 		  NextState <= st_st38;
		rtext <= 'b00001001;
	  end
	  st_st19: begin
		if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 1 )
 		  NextState <= st_st18;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st19;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st18;
		else if(ptext[2] == 1  && ptext[6] == 1 )
 		  NextState <= st_st18;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[2] == 1  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 0 )
 		  NextState <= st_st1;
		else if(ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st19;
		else if(ptext[0] == 0  && ptext[2] == 0 )
 		  NextState <= st_st19;
		rtext <= 'b01000000;
	  end
	  st_st20: begin
		if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st21;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st20;
		else if(ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1  && ptext[7] == 0 )
 		  NextState <= st_st12;
		else if(ptext[5] == 1  && ptext[7] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[7] == 0 )
 		  NextState <= st_st21;
		else if(ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st21;
		else if(ptext[1] == 1  && ptext[5] == 0  && ptext[7] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[5] == 0  && ptext[7] == 1 )
 		  NextState <= st_st20;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[5] == 0  && ptext[7] == 0 )
 		  NextState <= st_st20;
		else if(ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st20;
		else if(ptext[4] == 1  && ptext[7] == 1 )
 		  NextState <= st_st20;
		rtext <= 'b01100000;
	  end
	  st_st21: begin
		if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[7] == 0 )
 		  NextState <= st_st20;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st20;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st20;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 1  && ptext[7] == 1 )
 		  NextState <= st_st20;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[7] == 0 )
 		  NextState <= st_st20;
		else if(ptext[3] == 1  && ptext[7] == 1 )
 		  NextState <= st_st20;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[5] == 0  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 0 )
 		  NextState <= st_st21;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[7] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[7] == 1 )
 		  NextState <= st_st21;
		else if(ptext[1] == 0  && ptext[3] == 0 )
 		  NextState <= st_st21;
		rtext <= 'b00001110;
	  end
	  st_st22: begin
		if(ptext[1] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st12;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[7] == 1 )
 		  NextState <= st_st23;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st22;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st12;
		else if(ptext[1] == 0  && ptext[2] == 0 )
 		  NextState <= st_st12;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st23;
		else if(ptext[2] == 1  && ptext[6] == 1 )
 		  NextState <= st_st23;
		else if(ptext[2] == 1  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st22;
		else if(ptext[1] == 1  && ptext[2] == 0 )
 		  NextState <= st_st22;
		rtext <= 'b00000110;
	  end
	  st_st23: begin
		if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st23;
		else if(ptext[1] == 0  && ptext[3] == 1  && ptext[6] == 1 )
 		  NextState <= st_st22;
		else if(ptext[3] == 1  && ptext[7] == 1 )
 		  NextState <= st_st22;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[3] == 0  && ptext[6] == 1 )
 		  NextState <= st_st23;
		else if(ptext[3] == 0  && ptext[7] == 1 )
 		  NextState <= st_st23;
		rtext <= 'b00000001;
	  end
	  st_st24: begin
		if(ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st12;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st25;
		else if(ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st24;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st12;
		else if(ptext[1] == 0  && ptext[2] == 1 )
 		  NextState <= st_st12;
		else if(ptext[1] == 1  && ptext[3] == 1  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st25;
		else if(ptext[1] == 1  && ptext[5] == 0 )
 		  NextState <= st_st25;
		else if(ptext[1] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st24;
		else if(ptext[1] == 0  && ptext[2] == 0 )
 		  NextState <= st_st24;
		rtext <= 'b00111110;
	  end
	  st_st25: begin
		if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st24;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st25;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st24;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[6] == 1 )
 		  NextState <= st_st24;
		else if(ptext[1] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st24;
		else if(ptext[0] == 1  && ptext[4] == 0 )
 		  NextState <= st_st24;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[5] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st25;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st25;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[7] == 0 )
 		  NextState <= st_st25;
		else if(ptext[0] == 0  && ptext[5] == 0 )
 		  NextState <= st_st25;
		rtext <= 'b00001010;
	  end
	  st_st26: begin
		if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st27;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st26;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[7] == 1 )
 		  NextState <= st_st12;
		else if(ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st27;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1  && ptext[5] == 0  && ptext[7] == 1 )
 		  NextState <= st_st27;
		else if(ptext[2] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st27;
		else if(ptext[2] == 1  && ptext[5] == 0  && ptext[7] == 1 )
 		  NextState <= st_st27;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 0 )
 		  NextState <= st_st26;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[7] == 0 )
 		  NextState <= st_st26;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[5] == 0 )
 		  NextState <= st_st26;
		else if(ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st26;
		rtext <= 'b01010010;
	  end
	  st_st27: begin
		if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 0 )
 		  NextState <= st_st26;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st27;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[7] == 0 )
 		  NextState <= st_st26;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st26;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 0  && ptext[7] == 1 )
 		  NextState <= st_st26;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st26;
		else if(ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st26;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 1  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st27;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[7] == 0 )
 		  NextState <= st_st27;
		else if(ptext[3] == 0  && ptext[4] == 1  && ptext[7] == 0 )
 		  NextState <= st_st27;
		else if(ptext[0] == 0  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st27;
		else if(ptext[3] == 0  && ptext[6] == 0 )
 		  NextState <= st_st27;
		rtext <= 'b01000000;
	  end
	  st_st28: begin
		if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st29;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st28;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 1 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[3] == 1  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[2] == 1 )
 		  NextState <= st_st12;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st29;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[7] == 1 )
 		  NextState <= st_st29;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[5] == 0 )
 		  NextState <= st_st29;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[6] == 1 )
 		  NextState <= st_st29;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[7] == 0 )
 		  NextState <= st_st28;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[6] == 0 )
 		  NextState <= st_st28;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 1 )
 		  NextState <= st_st28;
		else if(ptext[0] == 1  && ptext[5] == 1 )
 		  NextState <= st_st28;
		rtext <= 'b00001000;
	  end
	  st_st29: begin
		if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st28;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st29;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st28;
		else if(ptext[1] == 1  && ptext[6] == 0 )
 		  NextState <= st_st28;
		else if(ptext[1] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st1;
		else if(ptext[2] == 0  && ptext[6] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[6] == 0 )
 		  NextState <= st_st29;
		else if(ptext[2] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st29;
		rtext <= 'b11001111;
	  end
	  st_st30: begin
		if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st31;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st30;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[7] == 1 )
 		  NextState <= st_st12;
		else if(ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 0 )
 		  NextState <= st_st12;
		else if(ptext[3] == 0  && ptext[6] == 0 )
 		  NextState <= st_st12;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[7] == 0 )
 		  NextState <= st_st31;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st31;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 1 )
 		  NextState <= st_st31;
		else if(ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st31;
		else if(ptext[0] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st30;
		else if(ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st30;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st30;
		else if(ptext[1] == 1  && ptext[3] == 1 )
 		  NextState <= st_st30;
		rtext <= 'b00010100;
	  end
	  st_st31: begin
		if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st30;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st31;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st30;
		else if(ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st30;
		else if(ptext[4] == 1  && ptext[7] == 1 )
 		  NextState <= st_st30;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 0 )
 		  NextState <= st_st1;
		else if(ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st31;
		else if(ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 0 )
 		  NextState <= st_st31;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0 )
 		  NextState <= st_st31;
		else if(ptext[0] == 0  && ptext[4] == 0 )
 		  NextState <= st_st31;
		rtext <= 'b01010000;
	  end
	  st_st32: begin
		if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st12;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st33;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st32;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[3] == 0  && ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st12;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st12;
		else if(ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st12;
		else if(ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st33;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st33;
		else if(ptext[0] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st33;
		else if(ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 0 )
 		  NextState <= st_st33;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[7] == 0 )
 		  NextState <= st_st32;
		else if(ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st32;
		else if(ptext[0] == 1  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st32;
		else if(ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st32;
		rtext <= 'b00010010;
	  end
	  st_st33: begin
		if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st32;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st33;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 0 )
 		  NextState <= st_st32;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 0 )
 		  NextState <= st_st32;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[7] == 1 )
 		  NextState <= st_st32;
		else if(ptext[2] == 1  && ptext[5] == 0 )
 		  NextState <= st_st32;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st1;
		else if(ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[5] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[7] == 0 )
 		  NextState <= st_st33;
		else if(ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 0 )
 		  NextState <= st_st33;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 0 )
 		  NextState <= st_st33;
		else if(ptext[0] == 0  && ptext[5] == 1 )
 		  NextState <= st_st33;
		rtext <= 'b00011000;
	  end
	  st_st34: begin
		if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[7] == 1 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st34;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st12;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st12;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st12;
		else if(ptext[2] == 0  && ptext[5] == 0 )
 		  NextState <= st_st12;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 0  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st34;
		else if(ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st34;
		else if(ptext[2] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st34;
		else if(ptext[1] == 1  && ptext[2] == 1 )
 		  NextState <= st_st34;
		rtext <= 'b00010100;
	  end
	  st_st35: begin
		if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 1 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st35;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st12;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st12;
		else if(ptext[0] == 1  && ptext[6] == 0 )
 		  NextState <= st_st12;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[7] == 1 )
 		  NextState <= st_st35;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st35;
		else if(ptext[1] == 0  && ptext[3] == 1  && ptext[6] == 1 )
 		  NextState <= st_st35;
		else if(ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st35;
		rtext <= 'b10000000;
	  end
	  st_st36: begin
		if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st12;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[7] == 1 )
 		  NextState <= st_st36;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st12;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st12;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st12;
		else if(ptext[2] == 1  && ptext[7] == 0 )
 		  NextState <= st_st12;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[5] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st36;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[7] == 0 )
 		  NextState <= st_st36;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st36;
		else if(ptext[2] == 0  && ptext[5] == 0 )
 		  NextState <= st_st36;
		rtext <= 'b10010110;
	  end
	  st_st37: begin
		if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st37;
		else if(ptext[0] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 0 )
 		  NextState <= st_st12;
		else if(ptext[3] == 1  && ptext[5] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[3] == 0  && ptext[5] == 0  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st37;
		else if(ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 0 )
 		  NextState <= st_st37;
		else if(ptext[0] == 1  && ptext[5] == 1  && ptext[7] == 0 )
 		  NextState <= st_st37;
		else if(ptext[1] == 0  && ptext[5] == 1 )
 		  NextState <= st_st37;
		rtext <= 'b00001011;
	  end
	  st_st38: begin
		if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st18;
		else if(ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st39;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st38;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 0  && ptext[7] == 1 )
 		  NextState <= st_st18;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st18;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[7] == 0 )
 		  NextState <= st_st18;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 1  && ptext[6] == 0 )
 		  NextState <= st_st18;
		else if(ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st18;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st39;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st39;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 1  && ptext[6] == 1 )
 		  NextState <= st_st39;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st39;
		else if(ptext[2] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st39;
		else if(ptext[3] == 0  && ptext[5] == 0  && ptext[7] == 1 )
 		  NextState <= st_st38;
		else if(ptext[2] == 0  && ptext[3] == 0  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st38;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[7] == 1 )
 		  NextState <= st_st38;
		else if(ptext[1] == 0  && ptext[7] == 1 )
 		  NextState <= st_st38;
		rtext <= 'b10001000;
	  end
	  st_st39: begin
		if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st38;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st40;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st39;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st38;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st38;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st38;
		else if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st38;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st40;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[7] == 0 )
 		  NextState <= st_st40;
		else if(ptext[1] == 1  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st40;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[5] == 0 )
 		  NextState <= st_st40;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st39;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[5] == 1 )
 		  NextState <= st_st39;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[5] == 1 )
 		  NextState <= st_st39;
		else if(ptext[1] == 1  && ptext[4] == 1 )
 		  NextState <= st_st39;
		rtext <= 'b10010001;
	  end
	  st_st40: begin
		if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st39;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st41;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st40;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 1  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st39;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 1  && ptext[5] == 0 )
 		  NextState <= st_st39;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st39;
		else if(ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st39;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st41;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st41;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st41;
		else if(ptext[1] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st41;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st40;
		else if(ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st40;
		else if(ptext[1] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st40;
		else if(ptext[1] == 0  && ptext[4] == 1 )
 		  NextState <= st_st40;
		rtext <= 'b00010010;
	  end
	  st_st41: begin
		if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st40;
		else if(ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st42;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[6] == 1 )
 		  NextState <= st_st41;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[7] == 1 )
 		  NextState <= st_st40;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st40;
		else if(ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st40;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st42;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st42;
		else if(ptext[0] == 0  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st42;
		else if(ptext[0] == 0  && ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st42;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[7] == 0 )
 		  NextState <= st_st41;
		else if(ptext[0] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st41;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 1 )
 		  NextState <= st_st41;
		else if(ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st41;
		rtext <= 'b01000001;
	  end
	  st_st42: begin
		if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[7] == 0 )
 		  NextState <= st_st41;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st43;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st42;
		else if(ptext[0] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st41;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st41;
		else if(ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st41;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st43;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st43;
		else if(ptext[2] == 1  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st43;
		else if(ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st43;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st42;
		else if(ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st42;
		else if(ptext[0] == 0  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st42;
		else if(ptext[2] == 0  && ptext[6] == 0 )
 		  NextState <= st_st42;
		rtext <= 'b00000000;
	  end
	  st_st43: begin
		if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st42;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st44;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st43;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st42;
		else if(ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st42;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st42;
		else if(ptext[0] == 0  && ptext[3] == 1 )
 		  NextState <= st_st42;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st44;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st44;
		else if(ptext[0] == 0  && ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st44;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 1 )
 		  NextState <= st_st44;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st43;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st43;
		else if(ptext[3] == 0  && ptext[5] == 0 )
 		  NextState <= st_st43;
		rtext <= 'b00010010;
	  end
	  st_st44: begin
		if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st43;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[7] == 1 )
 		  NextState <= st_st45;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st44;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st43;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[5] == 1 )
 		  NextState <= st_st43;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[7] == 1 )
 		  NextState <= st_st43;
		else if(ptext[0] == 0  && ptext[7] == 0 )
 		  NextState <= st_st43;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[7] == 1 )
 		  NextState <= st_st45;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st45;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0 )
 		  NextState <= st_st45;
		else if(ptext[0] == 0  && ptext[5] == 0  && ptext[7] == 1 )
 		  NextState <= st_st45;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st44;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st44;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[7] == 0 )
 		  NextState <= st_st44;
		else if(ptext[0] == 1  && ptext[3] == 1 )
 		  NextState <= st_st44;
		rtext <= 'b00101000;
	  end
	  st_st45: begin
		if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st44;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[7] == 0 )
 		  NextState <= st_st46;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st45;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st44;
		else if(ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 0 )
 		  NextState <= st_st44;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st44;
		else if(ptext[2] == 0  && ptext[7] == 0 )
 		  NextState <= st_st44;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[7] == 1 )
 		  NextState <= st_st46;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st46;
		else if(ptext[0] == 1  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st46;
		else if(ptext[2] == 1  && ptext[5] == 0  && ptext[7] == 0 )
 		  NextState <= st_st46;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st45;
		else if(ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 0 )
 		  NextState <= st_st45;
		else if(ptext[2] == 0  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st45;
		else if(ptext[0] == 0  && ptext[7] == 1 )
 		  NextState <= st_st45;
		rtext <= 'b00000000;
	  end
	  st_st46: begin
		if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st45;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st47;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st46;
		else if(ptext[0] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st45;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st45;
		else if(ptext[3] == 0  && ptext[7] == 0 )
 		  NextState <= st_st45;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st47;
		else if(ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st47;
		else if(ptext[1] == 0  && ptext[3] == 1  && ptext[5] == 0 )
 		  NextState <= st_st47;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[7] == 1 )
 		  NextState <= st_st47;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st46;
		else if(ptext[0] == 0  && ptext[3] == 0  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st46;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st46;
		else if(ptext[1] == 1  && ptext[3] == 1 )
 		  NextState <= st_st46;
		rtext <= 'b00010000;
	  end
	  st_st47: begin
		if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st46;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st48;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[7] == 1 )
 		  NextState <= st_st47;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st46;
		else if(ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st46;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st46;
		else if(ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st46;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st48;
		else if(ptext[1] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st48;
		else if(ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st48;
		else if(ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st48;
		else if(ptext[1] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st47;
		else if(ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st47;
		else if(ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st47;
		else if(ptext[2] == 1  && ptext[6] == 0 )
 		  NextState <= st_st47;
		rtext <= 'b00001100;
	  end
	  st_st48: begin
		if(ptext[0] == 0  && ptext[1] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st47;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st49;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st48;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st47;
		else if(ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 0 )
 		  NextState <= st_st47;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st47;
		else if(ptext[2] == 1  && ptext[5] == 1 )
 		  NextState <= st_st47;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0 )
 		  NextState <= st_st49;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 1  && ptext[7] == 0 )
 		  NextState <= st_st49;
		else if(ptext[0] == 0  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st49;
		else if(ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st49;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st48;
		else if(ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st48;
		else if(ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st48;
		else if(ptext[0] == 1  && ptext[5] == 0 )
 		  NextState <= st_st48;
		rtext <= 'b01000000;
	  end
	  st_st49: begin
		if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st48;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st50;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st49;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st48;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st48;
		else if(ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st48;
		else if(ptext[1] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st48;
		else if(ptext[1] == 1  && ptext[7] == 1 )
 		  NextState <= st_st48;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st50;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st50;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[7] == 0 )
 		  NextState <= st_st50;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st50;
		else if(ptext[1] == 0  && ptext[5] == 0  && ptext[7] == 1 )
 		  NextState <= st_st50;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st49;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st49;
		else if(ptext[1] == 0  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st49;
		else if(ptext[3] == 1  && ptext[5] == 0  && ptext[7] == 0 )
 		  NextState <= st_st49;
		else if(ptext[4] == 0  && ptext[7] == 0 )
 		  NextState <= st_st49;
		rtext <= 'b00001100;
	  end
	  st_st50: begin
		if(ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st49;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st51;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st50;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st49;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[6] == 1 )
 		  NextState <= st_st49;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[5] == 0  && ptext[7] == 1 )
 		  NextState <= st_st49;
		else if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st49;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[5] == 0  && ptext[7] == 1 )
 		  NextState <= st_st51;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st51;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[7] == 1 )
 		  NextState <= st_st51;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 1 )
 		  NextState <= st_st51;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[6] == 1 )
 		  NextState <= st_st50;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[5] == 1 )
 		  NextState <= st_st50;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st50;
		else if(ptext[1] == 0  && ptext[7] == 0 )
 		  NextState <= st_st50;
		rtext <= 'b10000000;
	  end
	  st_st51: begin
		if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 0 )
 		  NextState <= st_st50;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st52;
		else if(ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st51;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st50;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[7] == 0 )
 		  NextState <= st_st50;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st50;
		else if(ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st50;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st52;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st52;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[4] == 1 )
 		  NextState <= st_st52;
		else if(ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st52;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[7] == 1 )
 		  NextState <= st_st51;
		else if(ptext[2] == 1  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st51;
		else if(ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st51;
		else if(ptext[0] == 1  && ptext[4] == 1 )
 		  NextState <= st_st51;
		rtext <= 'b00101010;
	  end
	  st_st52: begin
		if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st51;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st53;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st52;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st51;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st51;
		else if(ptext[0] == 0  && ptext[6] == 0 )
 		  NextState <= st_st51;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st53;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st53;
		else if(ptext[1] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st53;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[6] == 0 )
 		  NextState <= st_st53;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st52;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[6] == 0 )
 		  NextState <= st_st52;
		else if(ptext[1] == 1  && ptext[3] == 1  && ptext[6] == 1 )
 		  NextState <= st_st52;
		else if(ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st52;
		rtext <= 'b00010001;
	  end
	  st_st53: begin
		if(ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st52;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st54;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st53;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st52;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st52;
		else if(ptext[0] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st52;
		else if(ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st52;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[7] == 0 )
 		  NextState <= st_st54;
		else if(ptext[0] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st54;
		else if(ptext[1] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st54;
		else if(ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st54;
		else if(ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st53;
		else if(ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st53;
		else if(ptext[0] == 1  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st53;
		else if(ptext[1] == 1  && ptext[4] == 0 )
 		  NextState <= st_st53;
		rtext <= 'b10000100;
	  end
	  st_st54: begin
		if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st53;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st55;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[7] == 0 )
 		  NextState <= st_st54;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st53;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[6] == 1 )
 		  NextState <= st_st53;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st53;
		else if(ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st53;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st55;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st55;
		else if(ptext[1] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st55;
		else if(ptext[3] == 0  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st55;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st54;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st54;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[6] == 0 )
 		  NextState <= st_st54;
		else if(ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st54;
		rtext <= 'b01010000;
	  end
	  st_st55: begin
		if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st54;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st56;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st55;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[6] == 1 )
 		  NextState <= st_st54;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[6] == 0 )
 		  NextState <= st_st54;
		else if(ptext[2] == 1  && ptext[5] == 0 )
 		  NextState <= st_st54;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st56;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st56;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st56;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[5] == 1 )
 		  NextState <= st_st56;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st55;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st55;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0 )
 		  NextState <= st_st55;
		else if(ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st55;
		rtext <= 'b10100110;
	  end
	  st_st56: begin
		if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st55;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st57;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st56;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 1  && ptext[7] == 0 )
 		  NextState <= st_st55;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st55;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[7] == 1 )
 		  NextState <= st_st55;
		else if(ptext[1] == 0  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st55;
		else if(ptext[2] == 1  && ptext[5] == 0 )
 		  NextState <= st_st55;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[7] == 1 )
 		  NextState <= st_st57;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st57;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st57;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st57;
		else if(ptext[2] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st57;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 0 )
 		  NextState <= st_st56;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st56;
		else if(ptext[2] == 1  && ptext[5] == 1  && ptext[7] == 0 )
 		  NextState <= st_st56;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[5] == 1 )
 		  NextState <= st_st56;
		else if(ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st56;
		rtext <= 'b11010000;
	  end
	  st_st57: begin
		if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st56;
		else if(ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st7;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st57;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1  && ptext[7] == 0 )
 		  NextState <= st_st56;
		else if(ptext[0] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 1 )
 		  NextState <= st_st56;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st56;
		else if(ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st56;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st7;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st7;
		else if(ptext[0] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st7;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st7;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st57;
		else if(ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st57;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st57;
		else if(ptext[0] == 0  && ptext[6] == 0 )
 		  NextState <= st_st57;
		rtext <= 'b11010000;
	  end
      endcase // case ( State )
   end // always @ (State or ptext)   
endmodule // fsm
