module fsm_rd_075 (RST, CLK, ptext, rtext);
//user interface
	input RST, CLK;
	input [11:0] ptext;
	output[7:0] rtext;
	reg [7:0] rtext;
//STATE ASSIGNMENTS
	`include "fsm_rd_075_stassign.v";
   //process modeling state register
   always @ (posedge RST or posedge CLK) begin
      if( RST == 1) begin
	 State <= st_st1;
      end
      else
	State <= NextState;
   end
   always @ (State or ptext) begin
      case ( State )
	  st_st1: begin
		if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0  && ptext[11] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 0  && ptext[11] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st6;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[9] == 1  && ptext[10] == 1  && ptext[11] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[9] == 0  && ptext[10] == 1  && ptext[11] == 1 )
 		  NextState <= st_st13;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[9] == 0  && ptext[10] == 1  && ptext[11] == 1 )
 		  NextState <= st_st16;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st17;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 0  && ptext[9] == 1  && ptext[10] == 1  && ptext[11] == 0 )
 		  NextState <= st_st20;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 0  && ptext[8] == 1  && ptext[11] == 0 )
 		  NextState <= st_st23;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0  && ptext[11] == 1 )
 		  NextState <= st_st33;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0  && ptext[11] == 1 )
 		  NextState <= st_st36;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[4] == 0  && ptext[6] == 0  && ptext[8] == 1  && ptext[10] == 1  && ptext[11] == 1 )
 		  NextState <= st_st2;
		else if(ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[8] == 0  && ptext[10] == 1  && ptext[11] == 0 )
 		  NextState <= st_st2;
		else if(ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[8] == 1  && ptext[10] == 0  && ptext[11] == 0 )
 		  NextState <= st_st2;
		else if(ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 0  && ptext[9] == 0  && ptext[11] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 0  && ptext[6] == 0  && ptext[8] == 0  && ptext[10] == 1  && ptext[11] == 1 )
 		  NextState <= st_st1;
		else if(ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 1  && ptext[11] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 1  && ptext[8] == 1  && ptext[10] == 0  && ptext[11] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 0  && ptext[8] == 1  && ptext[10] == 1  && ptext[11] == 1 )
 		  NextState <= st_st6;
		else if(ptext[1] == 1  && ptext[4] == 0  && ptext[6] == 0  && ptext[8] == 1  && ptext[11] == 0 )
 		  NextState <= st_st6;
		else if(ptext[0] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[9] == 1  && ptext[10] == 1  && ptext[11] == 1 )
 		  NextState <= st_st6;
		else if(ptext[1] == 1  && ptext[4] == 0  && ptext[6] == 0  && ptext[10] == 1 )
 		  NextState <= st_st6;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1  && ptext[8] == 1  && ptext[11] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 0  && ptext[11] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[6] == 1  && ptext[8] == 1 )
 		  NextState <= st_st9;
		else if(ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[8] == 1  && ptext[10] == 1  && ptext[11] == 0 )
 		  NextState <= st_st13;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st13;
		else if(ptext[1] == 1  && ptext[6] == 0  && ptext[9] == 0  && ptext[10] == 0  && ptext[11] == 1 )
 		  NextState <= st_st13;
		else if(ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 0  && ptext[11] == 1 )
 		  NextState <= st_st13;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[11] == 0 )
 		  NextState <= st_st16;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 1  && ptext[6] == 0  && ptext[8] == 1  && ptext[10] == 1  && ptext[11] == 0 )
 		  NextState <= st_st16;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[6] == 0  && ptext[9] == 0  && ptext[10] == 0  && ptext[11] == 1 )
 		  NextState <= st_st16;
		else if(ptext[3] == 1  && ptext[8] == 0  && ptext[10] == 0  && ptext[11] == 0 )
 		  NextState <= st_st16;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[6] == 1  && ptext[9] == 0  && ptext[10] == 0  && ptext[11] == 1 )
 		  NextState <= st_st17;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[8] == 1  && ptext[10] == 1  && ptext[11] == 0 )
 		  NextState <= st_st17;
		else if(ptext[3] == 0  && ptext[4] == 0  && ptext[8] == 0  && ptext[10] == 0  && ptext[11] == 0 )
 		  NextState <= st_st17;
		else if(ptext[4] == 1  && ptext[6] == 0  && ptext[8] == 1  && ptext[10] == 1  && ptext[11] == 1 )
 		  NextState <= st_st17;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 1  && ptext[6] == 1  && ptext[9] == 0  && ptext[10] == 0  && ptext[11] == 1 )
 		  NextState <= st_st20;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[8] == 1  && ptext[10] == 0  && ptext[11] == 0 )
 		  NextState <= st_st20;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[6] == 0  && ptext[8] == 1  && ptext[10] == 0  && ptext[11] == 1 )
 		  NextState <= st_st20;
		else if(ptext[3] == 0  && ptext[4] == 1  && ptext[8] == 0  && ptext[9] == 1  && ptext[11] == 0 )
 		  NextState <= st_st20;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[9] == 0  && ptext[11] == 1 )
 		  NextState <= st_st23;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 0  && ptext[11] == 1 )
 		  NextState <= st_st23;
		else if(ptext[0] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st23;
		else if(ptext[3] == 1  && ptext[4] == 1  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st23;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[9] == 0  && ptext[11] == 1 )
 		  NextState <= st_st33;
		else if(ptext[1] == 0  && ptext[4] == 0  && ptext[6] == 0  && ptext[8] == 0  && ptext[10] == 1  && ptext[11] == 0 )
 		  NextState <= st_st33;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st33;
		else if(ptext[3] == 0  && ptext[4] == 1  && ptext[8] == 0  && ptext[10] == 1  && ptext[11] == 1 )
 		  NextState <= st_st33;
		else if(ptext[3] == 0  && ptext[6] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1  && ptext[11] == 0 )
 		  NextState <= st_st36;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st36;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[4] == 0  && ptext[8] == 0  && ptext[10] == 1  && ptext[11] == 1 )
 		  NextState <= st_st36;
		else if(ptext[1] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[8] == 1  && ptext[11] == 0 )
 		  NextState <= st_st36;
		rtext <= 'b01111101;
	  end
	  st_st2: begin
		if(ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[9] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[9] == 0  && ptext[11] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[11] == 0 )
 		  NextState <= st_st2;
		else if(ptext[2] == 0  && ptext[3] == 0  && ptext[9] == 0  && ptext[11] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[9] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[9] == 0  && ptext[11] == 0 )
 		  NextState <= st_st3;
		else if(ptext[3] == 0  && ptext[4] == 0  && ptext[9] == 0  && ptext[11] == 0 )
 		  NextState <= st_st3;
		else if(ptext[2] == 1  && ptext[9] == 0 )
 		  NextState <= st_st3;
		else if(ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[9] == 0  && ptext[11] == 0 )
 		  NextState <= st_st2;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[9] == 0 )
 		  NextState <= st_st2;
		else if(ptext[1] == 1  && ptext[9] == 1 )
 		  NextState <= st_st2;
		rtext <= 'b01011000;
	  end
	  st_st3: begin
		if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st2;
		else if(ptext[1] == 1  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[10] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[6] == 0  && ptext[10] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[8] == 0 )
 		  NextState <= st_st2;
		else if(ptext[2] == 0  && ptext[7] == 1 )
 		  NextState <= st_st2;
		else if(ptext[1] == 0 )
 		  NextState <= st_st2;
		else if(ptext[1] == 1  && ptext[3] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[10] == 0 )
 		  NextState <= st_st4;
		else if(ptext[1] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st4;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[7] == 0 )
 		  NextState <= st_st4;
		else if(ptext[1] == 1  && ptext[2] == 1 )
 		  NextState <= st_st4;
		rtext <= 'b00110110;
	  end
	  st_st4: begin
		if(1)
 		  NextState <= st_st5;
		rtext <= 'b10110110;
	  end
	  st_st5: begin
		if(1)
 		  NextState <= st_st1;
		rtext <= 'b11110001;
	  end
	  st_st6: begin
		if(1)
 		  NextState <= st_st7;
		rtext <= 'b00111100;
	  end
	  st_st7: begin
		if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[9] == 1  && ptext[11] == 0 )
 		  NextState <= st_st8;
		else if(ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st7;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[8] == 1  && ptext[11] == 0 )
 		  NextState <= st_st8;
		else if(ptext[2] == 1  && ptext[7] == 0  && ptext[11] == 0 )
 		  NextState <= st_st8;
		else if(ptext[2] == 1  && ptext[5] == 1 )
 		  NextState <= st_st8;
		else if(ptext[10] == 0 )
 		  NextState <= st_st8;
		else if(ptext[3] == 1  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st7;
		else if(ptext[1] == 0  && ptext[5] == 0  && ptext[7] == 1  && ptext[10] == 1 )
 		  NextState <= st_st7;
		else if(ptext[5] == 0  && ptext[10] == 1  && ptext[11] == 1 )
 		  NextState <= st_st7;
		else if(ptext[2] == 0  && ptext[10] == 1 )
 		  NextState <= st_st7;
		rtext <= 'b10000100;
	  end
	  st_st8: begin
		if(ptext[3] == 1  && ptext[6] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[11] == 1 )
 		  NextState <= st_st7;
		else if(ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 1  && ptext[9] == 1 )
 		  NextState <= st_st1;
		else if(ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[11] == 1 )
 		  NextState <= st_st7;
		else if(ptext[3] == 1  && ptext[7] == 0  && ptext[11] == 1 )
 		  NextState <= st_st7;
		else if(ptext[1] == 0  && ptext[11] == 1 )
 		  NextState <= st_st7;
		else if(ptext[4] == 0 )
 		  NextState <= st_st7;
		else if(ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st1;
		else if(ptext[4] == 1  && ptext[11] == 0 )
 		  NextState <= st_st1;
		rtext <= 'b00010101;
	  end
	  st_st9: begin
		if(ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[10] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[3] == 1  && ptext[9] == 1  && ptext[10] == 1  && ptext[11] == 0 )
 		  NextState <= st_st10;
		else if(ptext[3] == 0  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[5] == 0  && ptext[8] == 1 )
 		  NextState <= st_st1;
		else if(ptext[5] == 0  && ptext[9] == 0 )
 		  NextState <= st_st1;
		else if(ptext[11] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[9] == 1  && ptext[11] == 0 )
 		  NextState <= st_st10;
		else if(ptext[0] == 0  && ptext[7] == 1  && ptext[9] == 1  && ptext[11] == 0 )
 		  NextState <= st_st10;
		else if(ptext[8] == 0  && ptext[9] == 1  && ptext[11] == 0 )
 		  NextState <= st_st10;
		else if(ptext[5] == 1  && ptext[11] == 0 )
 		  NextState <= st_st10;
		rtext <= 'b00011110;
	  end
	  st_st10: begin
		if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[5] == 0  && ptext[7] == 0 )
 		  NextState <= st_st9;
		else if(ptext[3] == 1  && ptext[7] == 1  && ptext[9] == 0  && ptext[10] == 0  && ptext[11] == 0 )
 		  NextState <= st_st11;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0 )
 		  NextState <= st_st9;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[11] == 1 )
 		  NextState <= st_st9;
		else if(ptext[2] == 1  && ptext[9] == 1 )
 		  NextState <= st_st9;
		else if(ptext[10] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[9] == 0  && ptext[10] == 0  && ptext[11] == 0 )
 		  NextState <= st_st11;
		else if(ptext[5] == 1  && ptext[9] == 0  && ptext[10] == 0  && ptext[11] == 0 )
 		  NextState <= st_st11;
		else if(ptext[1] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st11;
		else if(ptext[2] == 0  && ptext[10] == 0 )
 		  NextState <= st_st11;
		rtext <= 'b00100101;
	  end
	  st_st11: begin
		if(ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[8] == 0  && ptext[11] == 1 )
 		  NextState <= st_st10;
		else if(ptext[1] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st12;
		else if(ptext[2] == 1  && ptext[5] == 1  && ptext[7] == 1  && ptext[11] == 1 )
 		  NextState <= st_st10;
		else if(ptext[1] == 1  && ptext[5] == 1  && ptext[11] == 1 )
 		  NextState <= st_st10;
		else if(ptext[5] == 1  && ptext[10] == 0 )
 		  NextState <= st_st10;
		else if(ptext[6] == 0 )
 		  NextState <= st_st10;
		else if(ptext[1] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[10] == 1 )
 		  NextState <= st_st12;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[6] == 1  && ptext[10] == 1 )
 		  NextState <= st_st12;
		else if(ptext[6] == 1  && ptext[10] == 1  && ptext[11] == 0 )
 		  NextState <= st_st12;
		else if(ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st12;
		rtext <= 'b01100010;
	  end
	  st_st12: begin
		if(ptext[0] == 1  && ptext[3] == 1  && ptext[7] == 1  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st11;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[6] == 0  && ptext[9] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[9] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 1  && ptext[4] == 1 )
 		  NextState <= st_st11;
		else if(ptext[1] == 1 )
 		  NextState <= st_st11;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[4] == 0  && ptext[9] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st1;
		rtext <= 'b01101110;
	  end
	  st_st13: begin
		if(ptext[2] == 0  && ptext[8] == 0  && ptext[9] == 1  && ptext[10] == 0  && ptext[11] == 0 )
 		  NextState <= st_st14;
		else if(ptext[1] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 0  && ptext[9] == 0 )
 		  NextState <= st_st13;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st14;
		else if(ptext[2] == 0  && ptext[4] == 1  && ptext[8] == 0 )
 		  NextState <= st_st14;
		else if(ptext[5] == 1  && ptext[8] == 0 )
 		  NextState <= st_st14;
		else if(ptext[7] == 1 )
 		  NextState <= st_st14;
		else if(ptext[1] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 0  && ptext[11] == 1 )
 		  NextState <= st_st13;
		else if(ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 0  && ptext[10] == 1 )
 		  NextState <= st_st13;
		else if(ptext[2] == 1  && ptext[5] == 0  && ptext[7] == 0 )
 		  NextState <= st_st13;
		else if(ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st13;
		rtext <= 'b11111001;
	  end
	  st_st14: begin
		if(ptext[2] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[11] == 1 )
 		  NextState <= st_st13;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[11] == 1 )
 		  NextState <= st_st15;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[11] == 1 )
 		  NextState <= st_st14;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0 )
 		  NextState <= st_st13;
		else if(ptext[2] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[11] == 1 )
 		  NextState <= st_st13;
		else if(ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[11] == 1 )
 		  NextState <= st_st13;
		else if(ptext[1] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st13;
		else if(ptext[2] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[11] == 1 )
 		  NextState <= st_st13;
		else if(ptext[3] == 0  && ptext[7] == 0  && ptext[9] == 1  && ptext[11] == 0 )
 		  NextState <= st_st13;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[8] == 1 )
 		  NextState <= st_st13;
		else if(ptext[1] == 0  && ptext[11] == 0 )
 		  NextState <= st_st13;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[5] == 0  && ptext[7] == 0  && ptext[9] == 0  && ptext[11] == 0 )
 		  NextState <= st_st15;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 0 )
 		  NextState <= st_st15;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[11] == 1 )
 		  NextState <= st_st15;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 0  && ptext[11] == 1 )
 		  NextState <= st_st15;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 1  && ptext[11] == 1 )
 		  NextState <= st_st15;
		else if(ptext[1] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[11] == 0 )
 		  NextState <= st_st15;
		else if(ptext[2] == 1  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 1  && ptext[11] == 1 )
 		  NextState <= st_st15;
		else if(ptext[1] == 1  && ptext[3] == 1  && ptext[11] == 0 )
 		  NextState <= st_st15;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[6] == 0  && ptext[9] == 1  && ptext[11] == 1 )
 		  NextState <= st_st14;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[7] == 0  && ptext[8] == 1  && ptext[9] == 0 )
 		  NextState <= st_st14;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[9] == 0  && ptext[11] == 1 )
 		  NextState <= st_st14;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[11] == 1 )
 		  NextState <= st_st14;
		else if(ptext[2] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[11] == 1 )
 		  NextState <= st_st14;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[6] == 0  && ptext[11] == 1 )
 		  NextState <= st_st14;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[7] == 1  && ptext[11] == 0 )
 		  NextState <= st_st14;
		else if(ptext[8] == 0  && ptext[11] == 1 )
 		  NextState <= st_st14;
		rtext <= 'b00100001;
	  end
	  st_st15: begin
		if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[6] == 1  && ptext[8] == 0  && ptext[9] == 0 )
 		  NextState <= st_st16;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 0 )
 		  NextState <= st_st15;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st27;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[8] == 1 )
 		  NextState <= st_st30;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[9] == 1 )
 		  NextState <= st_st16;
		else if(ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[9] == 0 )
 		  NextState <= st_st16;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[8] == 1 )
 		  NextState <= st_st16;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[6] == 0  && ptext[8] == 0  && ptext[9] == 0 )
 		  NextState <= st_st15;
		else if(ptext[0] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[9] == 0 )
 		  NextState <= st_st15;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[8] == 0 )
 		  NextState <= st_st15;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[9] == 0 )
 		  NextState <= st_st27;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[8] == 0 )
 		  NextState <= st_st27;
		else if(ptext[3] == 0  && ptext[6] == 0 )
 		  NextState <= st_st27;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[8] == 0 )
 		  NextState <= st_st30;
		else if(ptext[3] == 0  && ptext[6] == 1  && ptext[9] == 1 )
 		  NextState <= st_st30;
		else if(ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st30;
		rtext <= 'b10001010;
	  end
	  st_st16: begin
		if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 1  && ptext[5] == 1  && ptext[9] == 0 )
 		  NextState <= st_st1;
		else if(ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st16;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[5] == 1  && ptext[9] == 0 )
 		  NextState <= st_st1;
		else if(ptext[5] == 1  && ptext[7] == 1  && ptext[9] == 0 )
 		  NextState <= st_st1;
		else if(ptext[4] == 1  && ptext[5] == 1 )
 		  NextState <= st_st1;
		else if(ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st16;
		else if(ptext[0] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st16;
		else if(ptext[4] == 0  && ptext[6] == 1  && ptext[9] == 1 )
 		  NextState <= st_st16;
		else if(ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st16;
		rtext <= 'b01110000;
	  end
	  st_st17: begin
		if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 0  && ptext[11] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[10] == 0 )
 		  NextState <= st_st18;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[11] == 0 )
 		  NextState <= st_st1;
		else if(ptext[4] == 1  && ptext[7] == 0  && ptext[11] == 0 )
 		  NextState <= st_st1;
		else if(ptext[10] == 1  && ptext[11] == 0 )
 		  NextState <= st_st1;
		else if(ptext[5] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[5] == 1  && ptext[7] == 1  && ptext[10] == 0 )
 		  NextState <= st_st18;
		else if(ptext[2] == 1  && ptext[5] == 1  && ptext[7] == 1  && ptext[10] == 0 )
 		  NextState <= st_st18;
		else if(ptext[4] == 0  && ptext[5] == 1  && ptext[10] == 0 )
 		  NextState <= st_st18;
		else if(ptext[5] == 1  && ptext[11] == 1 )
 		  NextState <= st_st18;
		rtext <= 'b01110101;
	  end
	  st_st18: begin
		if(1)
 		  NextState <= st_st19;
		rtext <= 'b11101111;
	  end
	  st_st19: begin
		if(1)
 		  NextState <= st_st7;
		rtext <= 'b11100101;
	  end
	  st_st20: begin
		if(1)
 		  NextState <= st_st21;
		rtext <= 'b10000011;
	  end
	  st_st21: begin
		if(ptext[0] == 0  && ptext[4] == 1  && ptext[7] == 0  && ptext[10] == 0  && ptext[11] == 1 )
 		  NextState <= st_st22;
		else if(ptext[2] == 0  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[7] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 0  && ptext[9] == 0 )
 		  NextState <= st_st22;
		else if(ptext[8] == 0 )
 		  NextState <= st_st22;
		else if(ptext[2] == 0  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 1  && ptext[11] == 0 )
 		  NextState <= st_st21;
		else if(ptext[4] == 0  && ptext[6] == 1  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st21;
		else if(ptext[7] == 1  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[8] == 1 )
 		  NextState <= st_st21;
		rtext <= 'b11010001;
	  end
	  st_st22: begin
		if(ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 0  && ptext[8] == 1  && ptext[11] == 1 )
 		  NextState <= st_st21;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[8] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st7;
		else if(ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 0  && ptext[9] == 1 )
 		  NextState <= st_st21;
		else if(ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st21;
		else if(ptext[1] == 1  && ptext[4] == 1 )
 		  NextState <= st_st21;
		else if(ptext[10] == 0 )
 		  NextState <= st_st21;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[9] == 0  && ptext[10] == 1  && ptext[11] == 0 )
 		  NextState <= st_st7;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[10] == 1 )
 		  NextState <= st_st7;
		else if(ptext[1] == 0  && ptext[6] == 1  && ptext[10] == 1 )
 		  NextState <= st_st7;
		else if(ptext[4] == 0  && ptext[10] == 1 )
 		  NextState <= st_st7;
		rtext <= 'b01100111;
	  end
	  st_st23: begin
		if(ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st24;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[5] == 0  && ptext[8] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[5] == 0 )
 		  NextState <= st_st1;
		else if(ptext[5] == 0  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[6] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[10] == 0 )
 		  NextState <= st_st24;
		else if(ptext[1] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st24;
		else if(ptext[2] == 1  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st24;
		else if(ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st24;
		rtext <= 'b11011011;
	  end
	  st_st24: begin
		if(ptext[0] == 1  && ptext[5] == 0  && ptext[7] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st23;
		else if(ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[8] == 1  && ptext[10] == 0 )
 		  NextState <= st_st25;
		else if(ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[9] == 0 )
 		  NextState <= st_st23;
		else if(ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 1 )
 		  NextState <= st_st23;
		else if(ptext[5] == 0  && ptext[8] == 0 )
 		  NextState <= st_st23;
		else if(ptext[3] == 0 )
 		  NextState <= st_st23;
		else if(ptext[0] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[8] == 1 )
 		  NextState <= st_st25;
		else if(ptext[3] == 1  && ptext[4] == 1  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st25;
		else if(ptext[3] == 1  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st25;
		else if(ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st25;
		rtext <= 'b01111011;
	  end
	  st_st25: begin
		if(ptext[0] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st24;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[7] == 0  && ptext[8] == 0  && ptext[10] == 0 )
 		  NextState <= st_st26;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[7] == 1  && ptext[9] == 0 )
 		  NextState <= st_st24;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[8] == 1 )
 		  NextState <= st_st24;
		else if(ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st24;
		else if(ptext[1] == 1 )
 		  NextState <= st_st24;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st26;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[8] == 0  && ptext[9] == 1 )
 		  NextState <= st_st26;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1 )
 		  NextState <= st_st26;
		else if(ptext[1] == 0  && ptext[3] == 1 )
 		  NextState <= st_st26;
		rtext <= 'b11000001;
	  end
	  st_st26: begin
		if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 0  && ptext[8] == 0 )
 		  NextState <= st_st25;
		else if(ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[10] == 0  && ptext[11] == 0 )
 		  NextState <= st_st7;
		else if(ptext[0] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[8] == 0 )
 		  NextState <= st_st25;
		else if(ptext[0] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st25;
		else if(ptext[0] == 1  && ptext[11] == 1 )
 		  NextState <= st_st25;
		else if(ptext[10] == 1 )
 		  NextState <= st_st25;
		else if(ptext[2] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[10] == 0  && ptext[11] == 0 )
 		  NextState <= st_st7;
		else if(ptext[6] == 1  && ptext[8] == 1  && ptext[10] == 0  && ptext[11] == 0 )
 		  NextState <= st_st7;
		else if(ptext[5] == 1  && ptext[10] == 0  && ptext[11] == 0 )
 		  NextState <= st_st7;
		else if(ptext[0] == 0  && ptext[10] == 0 )
 		  NextState <= st_st7;
		rtext <= 'b00000111;
	  end
	  st_st27: begin
		if(ptext[0] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[8] == 0 )
 		  NextState <= st_st15;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[6] == 0  && ptext[8] == 1  && ptext[10] == 1 )
 		  NextState <= st_st28;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[10] == 0 )
 		  NextState <= st_st15;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st15;
		else if(ptext[3] == 1  && ptext[6] == 1 )
 		  NextState <= st_st15;
		else if(ptext[1] == 0 )
 		  NextState <= st_st15;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[10] == 1 )
 		  NextState <= st_st28;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st28;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[6] == 0 )
 		  NextState <= st_st28;
		else if(ptext[1] == 1  && ptext[3] == 0 )
 		  NextState <= st_st28;
		rtext <= 'b10101010;
	  end
	  st_st28: begin
		if(1)
 		  NextState <= st_st29;
		rtext <= 'b10110100;
	  end
	  st_st29: begin
		if(1)
 		  NextState <= st_st5;
		rtext <= 'b10101010;
	  end
	  st_st30: begin
		if(1)
 		  NextState <= st_st31;
		rtext <= 'b11001000;
	  end
	  st_st31: begin
		if(ptext[0] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 0 )
 		  NextState <= st_st32;
		else if(ptext[2] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[10] == 0  && ptext[11] == 1 )
 		  NextState <= st_st31;
		else if(ptext[0] == 0  && ptext[4] == 1  && ptext[7] == 0  && ptext[10] == 1 )
 		  NextState <= st_st32;
		else if(ptext[2] == 1  && ptext[4] == 1  && ptext[7] == 0 )
 		  NextState <= st_st32;
		else if(ptext[7] == 0  && ptext[11] == 0 )
 		  NextState <= st_st32;
		else if(ptext[6] == 0 )
 		  NextState <= st_st32;
		else if(ptext[2] == 0  && ptext[3] == 0  && ptext[6] == 1  && ptext[10] == 0  && ptext[11] == 1 )
 		  NextState <= st_st31;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[6] == 1  && ptext[11] == 1 )
 		  NextState <= st_st31;
		else if(ptext[4] == 0  && ptext[6] == 1  && ptext[11] == 1 )
 		  NextState <= st_st31;
		else if(ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st31;
		rtext <= 'b00011110;
	  end
	  st_st32: begin
		if(ptext[0] == 0  && ptext[3] == 1  && ptext[7] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st31;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[5] == 0  && ptext[9] == 1  && ptext[11] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[7] == 0 )
 		  NextState <= st_st31;
		else if(ptext[1] == 1  && ptext[3] == 1  && ptext[7] == 0 )
 		  NextState <= st_st31;
		else if(ptext[2] == 0  && ptext[7] == 0 )
 		  NextState <= st_st31;
		else if(ptext[11] == 1 )
 		  NextState <= st_st31;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[5] == 0  && ptext[10] == 0  && ptext[11] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[11] == 0 )
 		  NextState <= st_st5;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[11] == 0 )
 		  NextState <= st_st5;
		else if(ptext[7] == 1  && ptext[11] == 0 )
 		  NextState <= st_st5;
		rtext <= 'b00101010;
	  end
	  st_st33: begin
		if(ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st34;
		else if(ptext[2] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[6] == 0  && ptext[10] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st34;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[6] == 1  && ptext[8] == 1 )
 		  NextState <= st_st34;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[6] == 1 )
 		  NextState <= st_st34;
		else if(ptext[0] == 1  && ptext[10] == 0 )
 		  NextState <= st_st34;
		rtext <= 'b10101100;
	  end
	  st_st34: begin
		if(1)
 		  NextState <= st_st35;
		rtext <= 'b11100101;
	  end
	  st_st35: begin
		if(1)
 		  NextState <= st_st7;
		rtext <= 'b00011111;
	  end
	  st_st36: begin
		if(1)
 		  NextState <= st_st37;
		rtext <= 'b01101100;
	  end
	  st_st37: begin
		if(ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[8] == 0  && ptext[11] == 0 )
 		  NextState <= st_st38;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[9] == 1 )
 		  NextState <= st_st37;
		else if(ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[8] == 0 )
 		  NextState <= st_st38;
		else if(ptext[1] == 1  && ptext[5] == 0  && ptext[8] == 0 )
 		  NextState <= st_st38;
		else if(ptext[0] == 1  && ptext[5] == 0 )
 		  NextState <= st_st38;
		else if(ptext[9] == 0 )
 		  NextState <= st_st38;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[4] == 1  && ptext[9] == 1  && ptext[11] == 1 )
 		  NextState <= st_st37;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[6] == 0  && ptext[9] == 1 )
 		  NextState <= st_st37;
		else if(ptext[0] == 0  && ptext[8] == 1  && ptext[9] == 1 )
 		  NextState <= st_st37;
		else if(ptext[5] == 1  && ptext[9] == 1 )
 		  NextState <= st_st37;
		rtext <= 'b11111111;
	  end
	  st_st38: begin
		if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st37;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[11] == 1 )
 		  NextState <= st_st7;
		else if(ptext[2] == 1  && ptext[4] == 0  && ptext[9] == 0  && ptext[10] == 1 )
 		  NextState <= st_st37;
		else if(ptext[2] == 1  && ptext[10] == 1  && ptext[11] == 0 )
 		  NextState <= st_st37;
		else if(ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st37;
		else if(ptext[6] == 0 )
 		  NextState <= st_st37;
		else if(ptext[0] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[11] == 1 )
 		  NextState <= st_st7;
		else if(ptext[3] == 0  && ptext[6] == 1  && ptext[9] == 1  && ptext[11] == 1 )
 		  NextState <= st_st7;
		else if(ptext[3] == 0  && ptext[6] == 1  && ptext[10] == 0 )
 		  NextState <= st_st7;
		else if(ptext[2] == 0  && ptext[6] == 1 )
 		  NextState <= st_st7;
		rtext <= 'b01111001;
	  end
      endcase // case ( State )
   end // always @ (State or ptext)   
endmodule // fsm
