module fsm_rd_081 (RST, CLK, ptext, rtext);
//user interface
	input RST, CLK;
	input [9:0] ptext;
	output[11:0] rtext;
	reg [11:0] rtext;
//STATE ASSIGNMENTS
	`include "fsm_rd_081_stassign.v";
   //process modeling state register
   always @ (posedge RST or posedge CLK) begin
      if( RST == 1) begin
	 State <= st_st1;
      end
      else
	State <= NextState;
   end
   always @ (State or ptext) begin
      case ( State )
	  st_st1: begin
		if(1)
 		  NextState <= st_st2;
		rtext <= 'b101001100100;
	  end
	  st_st2: begin
		if(ptext[7] == 0 )
 		  NextState <= st_st3;
		else if(ptext[7] == 1 )
 		  NextState <= st_st2;
		rtext <= 'b101100101101;
	  end
	  st_st3: begin
		if(ptext[3] == 0 )
 		  NextState <= st_st4;
		else if(ptext[3] == 1 )
 		  NextState <= st_st3;
		rtext <= 'b001001111000;
	  end
	  st_st4: begin
		if(ptext[1] == 1  && ptext[6] == 1 )
 		  NextState <= st_st5;
		else if(ptext[6] == 0 )
 		  NextState <= st_st4;
		else if(ptext[1] == 0  && ptext[6] == 1 )
 		  NextState <= st_st24;
		rtext <= 'b010110101111;
	  end
	  st_st5: begin
		if(ptext[4] == 0  && ptext[8] == 1 )
 		  NextState <= st_st4;
		else if(ptext[4] == 1 )
 		  NextState <= st_st6;
		else if(ptext[4] == 0  && ptext[8] == 0 )
 		  NextState <= st_st5;
		rtext <= 'b010100000101;
	  end
	  st_st6: begin
		if(1)
 		  NextState <= st_st7;
		rtext <= 'b101100000110;
	  end
	  st_st7: begin
		if(ptext[3] == 0 )
 		  NextState <= st_st8;
		else if(ptext[3] == 1 )
 		  NextState <= st_st7;
		rtext <= 'b011100101100;
	  end
	  st_st8: begin
		if(ptext[7] == 0 )
 		  NextState <= st_st9;
		else if(ptext[7] == 1 )
 		  NextState <= st_st8;
		rtext <= 'b110100000101;
	  end
	  st_st9: begin
		if(ptext[0] == 0  && ptext[5] == 1 )
 		  NextState <= st_st8;
		else if(ptext[5] == 0 )
 		  NextState <= st_st10;
		else if(ptext[0] == 1  && ptext[5] == 1 )
 		  NextState <= st_st9;
		rtext <= 'b101001010000;
	  end
	  st_st10: begin
		if(ptext[3] == 1  && ptext[5] == 1 )
 		  NextState <= st_st9;
		else if(ptext[5] == 0 )
 		  NextState <= st_st11;
		else if(ptext[3] == 0  && ptext[5] == 1 )
 		  NextState <= st_st10;
		rtext <= 'b000000000100;
	  end
	  st_st11: begin
		if(1)
 		  NextState <= st_st12;
		rtext <= 'b000001101110;
	  end
	  st_st12: begin
		if(ptext[0] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 1 )
 		  NextState <= st_st13;
		rtext <= 'b100110001100;
	  end
	  st_st13: begin
		if(ptext[9] == 0 )
 		  NextState <= st_st14;
		else if(ptext[9] == 1 )
 		  NextState <= st_st13;
		rtext <= 'b101100000001;
	  end
	  st_st14: begin
		if(ptext[3] == 1 )
 		  NextState <= st_st15;
		else if(ptext[3] == 0 )
 		  NextState <= st_st14;
		rtext <= 'b010000110000;
	  end
	  st_st15: begin
		if(ptext[4] == 1  && ptext[8] == 0 )
 		  NextState <= st_st14;
		else if(ptext[4] == 0  && ptext[8] == 0 )
 		  NextState <= st_st16;
		else if(ptext[4] == 0  && ptext[8] == 1 )
 		  NextState <= st_st15;
		else if(ptext[4] == 1  && ptext[8] == 1 )
 		  NextState <= st_st16;
		rtext <= 'b001100101000;
	  end
	  st_st16: begin
		if(ptext[4] == 0 )
 		  NextState <= st_st17;
		else if(ptext[4] == 1 )
 		  NextState <= st_st16;
		rtext <= 'b011010010101;
	  end
	  st_st17: begin
		if(ptext[5] == 1 )
 		  NextState <= st_st18;
		else if(ptext[5] == 0 )
 		  NextState <= st_st17;
		rtext <= 'b001010001010;
	  end
	  st_st18: begin
		if(ptext[7] == 0 )
 		  NextState <= st_st19;
		else if(ptext[7] == 1 )
 		  NextState <= st_st18;
		rtext <= 'b101100101000;
	  end
	  st_st19: begin
		if(ptext[1] == 1 )
 		  NextState <= st_st20;
		else if(ptext[1] == 0 )
 		  NextState <= st_st19;
		rtext <= 'b001110010101;
	  end
	  st_st20: begin
		if(ptext[4] == 0  && ptext[7] == 1 )
 		  NextState <= st_st19;
		else if(ptext[4] == 0  && ptext[7] == 0 )
 		  NextState <= st_st21;
		else if(ptext[4] == 1  && ptext[7] == 0 )
 		  NextState <= st_st20;
		else if(ptext[4] == 1  && ptext[7] == 1 )
 		  NextState <= st_st21;
		rtext <= 'b101011110101;
	  end
	  st_st21: begin
		if(1)
 		  NextState <= st_st22;
		rtext <= 'b101001010010;
	  end
	  st_st22: begin
		if(1)
 		  NextState <= st_st23;
		rtext <= 'b000001010110;
	  end
	  st_st23: begin
		if(ptext[9] == 1 )
 		  NextState <= st_st1;
		else if(ptext[9] == 0 )
 		  NextState <= st_st23;
		rtext <= 'b011100011010;
	  end
	  st_st24: begin
		if(ptext[0] == 0  && ptext[8] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 0  && ptext[8] == 1 )
 		  NextState <= st_st25;
		else if(ptext[0] == 1  && ptext[8] == 1 )
 		  NextState <= st_st32;
		else if(ptext[0] == 1  && ptext[8] == 0 )
 		  NextState <= st_st24;
		rtext <= 'b101111000000;
	  end
	  st_st25: begin
		if(1)
 		  NextState <= st_st26;
		rtext <= 'b111011011111;
	  end
	  st_st26: begin
		if(ptext[0] == 0 )
 		  NextState <= st_st27;
		else if(ptext[0] == 1 )
 		  NextState <= st_st26;
		rtext <= 'b101101001001;
	  end
	  st_st27: begin
		if(ptext[6] == 1 )
 		  NextState <= st_st28;
		else if(ptext[6] == 0 )
 		  NextState <= st_st27;
		rtext <= 'b111100000011;
	  end
	  st_st28: begin
		if(ptext[6] == 0 )
 		  NextState <= st_st29;
		else if(ptext[6] == 1 )
 		  NextState <= st_st28;
		rtext <= 'b101100011100;
	  end
	  st_st29: begin
		if(ptext[1] == 0  && ptext[2] == 0 )
 		  NextState <= st_st28;
		else if(ptext[1] == 1 )
 		  NextState <= st_st30;
		else if(ptext[1] == 0  && ptext[2] == 1 )
 		  NextState <= st_st29;
		rtext <= 'b100110001000;
	  end
	  st_st30: begin
		if(ptext[3] == 0 )
 		  NextState <= st_st31;
		else if(ptext[3] == 1 )
 		  NextState <= st_st30;
		rtext <= 'b011011010011;
	  end
	  st_st31: begin
		if(1)
 		  NextState <= st_st18;
		rtext <= 'b001100011100;
	  end
	  st_st32: begin
		if(1)
 		  NextState <= st_st33;
		rtext <= 'b100100001000;
	  end
	  st_st33: begin
		if(1)
 		  NextState <= st_st34;
		rtext <= 'b001100111100;
	  end
	  st_st34: begin
		if(1)
 		  NextState <= st_st35;
		rtext <= 'b111000101011;
	  end
	  st_st35: begin
		if(ptext[3] == 1 )
 		  NextState <= st_st36;
		else if(ptext[3] == 0 )
 		  NextState <= st_st35;
		rtext <= 'b101000001001;
	  end
	  st_st36: begin
		if(ptext[5] == 1 )
 		  NextState <= st_st37;
		else if(ptext[5] == 0 )
 		  NextState <= st_st36;
		rtext <= 'b000110011101;
	  end
	  st_st37: begin
		if(1)
 		  NextState <= st_st38;
		rtext <= 'b000001011100;
	  end
	  st_st38: begin
		if(ptext[6] == 0 )
 		  NextState <= st_st39;
		else if(ptext[6] == 1 )
 		  NextState <= st_st38;
		rtext <= 'b101010111101;
	  end
	  st_st39: begin
		if(ptext[9] == 1 )
 		  NextState <= st_st9;
		else if(ptext[9] == 0 )
 		  NextState <= st_st39;
		rtext <= 'b101010111101;
	  end
      endcase // case ( State )
   end // always @ (State or ptext)   
endmodule // fsm
