module fsm_rd_085 (RST, CLK, ptext, rtext);
//user interface
	input RST, CLK;
	input [7:0] ptext;
	output[11:0] rtext;
	reg [11:0] rtext;
//STATE ASSIGNMENTS
	`include "fsm_rd_085_stassign.v";
   //process modeling state register
   always @ (posedge RST or posedge CLK) begin
      if( RST == 1) begin
	 State <= st_st1;
      end
      else
	State <= NextState;
   end
   always @ (State or ptext) begin
      case ( State )
	  st_st1: begin
		if(ptext[1] == 0 )
 		  NextState <= st_st2;
		else if(ptext[1] == 1 )
 		  NextState <= st_st1;
		rtext <= 'b101000101010;
	  end
	  st_st2: begin
		if(1)
 		  NextState <= st_st3;
		rtext <= 'b111000100111;
	  end
	  st_st3: begin
		if(ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st4;
		else if(ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st3;
		else if(ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st23;
		else if(ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st3;
		rtext <= 'b001001011010;
	  end
	  st_st4: begin
		if(ptext[3] == 1 )
 		  NextState <= st_st5;
		else if(ptext[3] == 0 )
 		  NextState <= st_st32;
		rtext <= 'b011100010000;
	  end
	  st_st5: begin
		if(ptext[5] == 0 )
 		  NextState <= st_st6;
		else if(ptext[5] == 1 )
 		  NextState <= st_st5;
		rtext <= 'b011100110110;
	  end
	  st_st6: begin
		if(1)
 		  NextState <= st_st7;
		rtext <= 'b011000111100;
	  end
	  st_st7: begin
		if(ptext[2] == 0 )
 		  NextState <= st_st8;
		else if(ptext[2] == 1 )
 		  NextState <= st_st7;
		rtext <= 'b001100100010;
	  end
	  st_st8: begin
		if(ptext[6] == 0 )
 		  NextState <= st_st7;
		else if(ptext[6] == 1 )
 		  NextState <= st_st9;
		rtext <= 'b111001010010;
	  end
	  st_st9: begin
		if(1)
 		  NextState <= st_st10;
		rtext <= 'b011000000000;
	  end
	  st_st10: begin
		if(1)
 		  NextState <= st_st11;
		rtext <= 'b000000100110;
	  end
	  st_st11: begin
		if(ptext[6] == 0 )
 		  NextState <= st_st12;
		else if(ptext[6] == 1 )
 		  NextState <= st_st11;
		rtext <= 'b001100000110;
	  end
	  st_st12: begin
		if(1)
 		  NextState <= st_st13;
		rtext <= 'b001000100001;
	  end
	  st_st13: begin
		if(ptext[7] == 1 )
 		  NextState <= st_st14;
		else if(ptext[7] == 0 )
 		  NextState <= st_st13;
		rtext <= 'b110000110000;
	  end
	  st_st14: begin
		if(ptext[4] == 1 )
 		  NextState <= st_st15;
		else if(ptext[4] == 0 )
 		  NextState <= st_st14;
		rtext <= 'b011100100010;
	  end
	  st_st15: begin
		if(ptext[2] == 0 )
 		  NextState <= st_st14;
		else if(ptext[2] == 1 )
 		  NextState <= st_st16;
		rtext <= 'b011010010101;
	  end
	  st_st16: begin
		if(1)
 		  NextState <= st_st17;
		rtext <= 'b101010101010;
	  end
	  st_st17: begin
		if(1)
 		  NextState <= st_st18;
		rtext <= 'b001100100110;
	  end
	  st_st18: begin
		if(ptext[1] == 1  && ptext[7] == 1 )
 		  NextState <= st_st17;
		else if(ptext[1] == 0 )
 		  NextState <= st_st19;
		else if(ptext[1] == 1  && ptext[7] == 0 )
 		  NextState <= st_st18;
		rtext <= 'b111001010111;
	  end
	  st_st19: begin
		if(1)
 		  NextState <= st_st20;
		rtext <= 'b000010110111;
	  end
	  st_st20: begin
		if(1)
 		  NextState <= st_st21;
		rtext <= 'b111100110010;
	  end
	  st_st21: begin
		if(ptext[5] == 0 )
 		  NextState <= st_st22;
		else if(ptext[5] == 1 )
 		  NextState <= st_st21;
		rtext <= 'b001000010010;
	  end
	  st_st22: begin
		if(ptext[5] == 1 )
 		  NextState <= st_st21;
		else if(ptext[5] == 0 )
 		  NextState <= st_st1;
		rtext <= 'b010000101111;
	  end
	  st_st23: begin
		if(ptext[5] == 0 )
 		  NextState <= st_st3;
		else if(ptext[5] == 1 )
 		  NextState <= st_st24;
		rtext <= 'b111111100010;
	  end
	  st_st24: begin
		if(ptext[6] == 0 )
 		  NextState <= st_st25;
		else if(ptext[6] == 1 )
 		  NextState <= st_st24;
		rtext <= 'b011111001010;
	  end
	  st_st25: begin
		if(1)
 		  NextState <= st_st26;
		rtext <= 'b111011010110;
	  end
	  st_st26: begin
		if(ptext[4] == 0 )
 		  NextState <= st_st27;
		else if(ptext[4] == 1 )
 		  NextState <= st_st26;
		rtext <= 'b101101101001;
	  end
	  st_st27: begin
		if(ptext[0] == 0 )
 		  NextState <= st_st28;
		else if(ptext[0] == 1 )
 		  NextState <= st_st27;
		rtext <= 'b010000100010;
	  end
	  st_st28: begin
		if(ptext[1] == 0 )
 		  NextState <= st_st29;
		else if(ptext[1] == 1 )
 		  NextState <= st_st28;
		rtext <= 'b101101011000;
	  end
	  st_st29: begin
		if(1)
 		  NextState <= st_st30;
		rtext <= 'b000110101001;
	  end
	  st_st30: begin
		if(1)
 		  NextState <= st_st31;
		rtext <= 'b101011110000;
	  end
	  st_st31: begin
		if(ptext[7] == 1 )
 		  NextState <= st_st5;
		else if(ptext[7] == 0 )
 		  NextState <= st_st31;
		rtext <= 'b011100000100;
	  end
	  st_st32: begin
		if(1)
 		  NextState <= st_st33;
		rtext <= 'b001100101010;
	  end
	  st_st33: begin
		if(ptext[2] == 0 )
 		  NextState <= st_st34;
		else if(ptext[2] == 1 )
 		  NextState <= st_st33;
		rtext <= 'b011100111110;
	  end
	  st_st34: begin
		if(1)
 		  NextState <= st_st35;
		rtext <= 'b111000101111;
	  end
	  st_st35: begin
		if(1)
 		  NextState <= st_st36;
		rtext <= 'b101000000000;
	  end
	  st_st36: begin
		if(1)
 		  NextState <= st_st37;
		rtext <= 'b100010011110;
	  end
	  st_st37: begin
		if(ptext[2] == 1 )
 		  NextState <= st_st38;
		else if(ptext[2] == 0 )
 		  NextState <= st_st37;
		rtext <= 'b000011001100;
	  end
	  st_st38: begin
		if(ptext[2] == 0  && ptext[4] == 1 )
 		  NextState <= st_st37;
		else if(ptext[2] == 1 )
 		  NextState <= st_st39;
		else if(ptext[2] == 0  && ptext[4] == 0 )
 		  NextState <= st_st38;
		rtext <= 'b011010110001;
	  end
	  st_st39: begin
		if(1)
 		  NextState <= st_st16;
		rtext <= 'b011010110001;
	  end
      endcase // case ( State )
   end // always @ (State or ptext)   
endmodule // fsm
