module fsm_rd_090 (RST, CLK, ptext, rtext);
//user interface
	input RST, CLK;
	input [8:0] ptext;
	output[8:0] rtext;
	reg [8:0] rtext;
//STATE ASSIGNMENTS
	`include "fsm_rd_090_stassign.v";
   //process modeling state register
   always @ (posedge RST or posedge CLK) begin
      if( RST == 1) begin
	 State <= st_st1;
      end
      else
	State <= NextState;
   end
   always @ (State or ptext) begin
      case ( State )
	  st_st1: begin
		if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[8] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st3;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st4;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st8;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st10;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st3;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[8] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[6] == 0  && ptext[8] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 0  && ptext[8] == 1 )
 		  NextState <= st_st2;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st2;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[6] == 0  && ptext[8] == 1 )
 		  NextState <= st_st2;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[8] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[8] == 0 )
 		  NextState <= st_st1;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[8] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[7] == 1 )
 		  NextState <= st_st3;
		else if(ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st3;
		else if(ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[8] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st4;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 1 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st5;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 1 )
 		  NextState <= st_st5;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 1 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[7] == 0 )
 		  NextState <= st_st5;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st8;
		else if(ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st8;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st8;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st9;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st9;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st3;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st3;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[8] == 1 )
 		  NextState <= st_st10;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st10;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 0 )
 		  NextState <= st_st10;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st11;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[8] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st3;
		rtext <= 'b001101000;
	  end
	  st_st2: begin
		if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[8] == 1 )
 		  NextState <= st_st1;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[8] == 0 )
 		  NextState <= st_st1;
		else if(ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[5] == 1  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[8] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[8] == 0 )
 		  NextState <= st_st1;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[3] == 1  && ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[8] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[8] == 0 )
 		  NextState <= st_st2;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st2;
		else if(ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st2;
		else if(ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st2;
		rtext <= 'b000001110;
	  end
	  st_st3: begin
		if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st4;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 0  && ptext[8] == 1 )
 		  NextState <= st_st5;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st10;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st11;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[8] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[8] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[8] == 0 )
 		  NextState <= st_st3;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st3;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[6] == 0  && ptext[8] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[8] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[8] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st4;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st4;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[5] == 1  && ptext[8] == 1 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 1 )
 		  NextState <= st_st5;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st5;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st5;
		else if(ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st5;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[5] == 1  && ptext[8] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[8] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[8] == 0 )
 		  NextState <= st_st10;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st10;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[8] == 0 )
 		  NextState <= st_st10;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st10;
		else if(ptext[1] == 1  && ptext[3] == 1  && ptext[5] == 1  && ptext[7] == 0 )
 		  NextState <= st_st10;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st11;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st11;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st11;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st1;
		rtext <= 'b110011010;
	  end
	  st_st4: begin
		if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[8] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[8] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st6;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st7;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st5;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1 )
 		  NextState <= st_st4;
		else if(ptext[0] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st4;
		else if(ptext[2] == 0  && ptext[3] == 0  && ptext[7] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[8] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st5;
		else if(ptext[1] == 1  && ptext[3] == 1  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st5;
		else if(ptext[4] == 1  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st6;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st6;
		else if(ptext[0] == 0  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st6;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[8] == 0 )
 		  NextState <= st_st6;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[7] == 0 )
 		  NextState <= st_st6;
		else if(ptext[1] == 1  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st6;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[8] == 0 )
 		  NextState <= st_st7;
		else if(ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st7;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st7;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 0  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st7;
		else if(ptext[1] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st7;
		else if(ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st5;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 0 )
 		  NextState <= st_st5;
		else if(ptext[1] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st5;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st5;
		else if(ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[8] == 0 )
 		  NextState <= st_st5;
		rtext <= 'b011000010;
	  end
	  st_st5: begin
		if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st5;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 0 )
 		  NextState <= st_st4;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st6;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st7;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 0 )
 		  NextState <= st_st8;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 0  && ptext[7] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 0 )
 		  NextState <= st_st4;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[8] == 0 )
 		  NextState <= st_st4;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st4;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st6;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[8] == 1 )
 		  NextState <= st_st6;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st6;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[8] == 0 )
 		  NextState <= st_st6;
		else if(ptext[0] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st7;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st7;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[8] == 0 )
 		  NextState <= st_st7;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[8] == 1 )
 		  NextState <= st_st7;
		else if(ptext[0] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st4;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[8] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[8] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 0  && ptext[8] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[8] == 0 )
 		  NextState <= st_st8;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[7] == 1 )
 		  NextState <= st_st8;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st8;
		else if(ptext[0] == 1  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st8;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st9;
		else if(ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st9;
		rtext <= 'b101000000;
	  end
	  st_st6: begin
		if(ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 0  && ptext[8] == 1 )
 		  NextState <= st_st6;
		else if(ptext[2] == 1  && ptext[4] == 0  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st4;
		else if(ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st4;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 0 )
 		  NextState <= st_st5;
		else if(ptext[2] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st5;
		else if(ptext[2] == 1  && ptext[8] == 0 )
 		  NextState <= st_st5;
		else if(ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[8] == 1 )
 		  NextState <= st_st6;
		else if(ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st6;
		else if(ptext[2] == 1  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st6;
		rtext <= 'b100000100;
	  end
	  st_st7: begin
		if(ptext[0] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[8] == 1 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st5;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 0  && ptext[8] == 1 )
 		  NextState <= st_st7;
		else if(ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[6] == 1 )
 		  NextState <= st_st4;
		else if(ptext[2] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st4;
		else if(ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st4;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st5;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st5;
		else if(ptext[2] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 0  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st7;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[6] == 0  && ptext[8] == 1 )
 		  NextState <= st_st7;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st7;
		else if(ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st7;
		else if(ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st7;
		rtext <= 'b011001010;
	  end
	  st_st8: begin
		if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[8] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st5;
		else if(ptext[0] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[8] == 1 )
 		  NextState <= st_st8;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 0  && ptext[8] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 1 )
 		  NextState <= st_st5;
		else if(ptext[4] == 0  && ptext[5] == 0  && ptext[8] == 0 )
 		  NextState <= st_st5;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 0  && ptext[8] == 1 )
 		  NextState <= st_st8;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st8;
		else if(ptext[0] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[8] == 1 )
 		  NextState <= st_st8;
		else if(ptext[2] == 1  && ptext[4] == 1 )
 		  NextState <= st_st8;
		else if(ptext[4] == 1  && ptext[7] == 0 )
 		  NextState <= st_st8;
		rtext <= 'b100110001;
	  end
	  st_st9: begin
		if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[8] == 0 )
 		  NextState <= st_st9;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[5] == 1  && ptext[8] == 0 )
 		  NextState <= st_st1;
		else if(ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[8] == 0 )
 		  NextState <= st_st1;
		else if(ptext[2] == 0  && ptext[3] == 0  && ptext[6] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st1;
		else if(ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st5;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[6] == 0  && ptext[8] == 1 )
 		  NextState <= st_st5;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 0 )
 		  NextState <= st_st5;
		else if(ptext[4] == 1  && ptext[6] == 0  && ptext[8] == 1 )
 		  NextState <= st_st5;
		else if(ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[8] == 0 )
 		  NextState <= st_st9;
		else if(ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st9;
		else if(ptext[2] == 1  && ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st9;
		else if(ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 0  && ptext[8] == 0 )
 		  NextState <= st_st9;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0  && ptext[7] == 1 )
 		  NextState <= st_st9;
		else if(ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st9;
		rtext <= 'b110100010;
	  end
	  st_st10: begin
		if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st3;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 1 )
 		  NextState <= st_st10;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[5] == 1  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[7] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[6] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[8] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 1  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 1  && ptext[8] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[4] == 0  && ptext[8] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 0 )
 		  NextState <= st_st10;
		else if(ptext[0] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[8] == 1 )
 		  NextState <= st_st10;
		else if(ptext[0] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[8] == 0 )
 		  NextState <= st_st10;
		else if(ptext[0] == 1  && ptext[1] == 0 )
 		  NextState <= st_st10;
		else if(ptext[0] == 1  && ptext[2] == 0 )
 		  NextState <= st_st10;
		rtext <= 'b001001001;
	  end
	  st_st11: begin
		if(ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st11;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 0 )
 		  NextState <= st_st3;
		else if(ptext[4] == 0  && ptext[5] == 1  && ptext[6] == 0  && ptext[8] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[7] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[4] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 0  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[6] == 0  && ptext[7] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1  && ptext[7] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[4] == 0  && ptext[8] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 1 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0  && ptext[4] == 0  && ptext[6] == 1  && ptext[8] == 1 )
 		  NextState <= st_st11;
		else if(ptext[4] == 1  && ptext[7] == 1 )
 		  NextState <= st_st11;
		else if(ptext[1] == 0  && ptext[4] == 1 )
 		  NextState <= st_st11;
		rtext <= 'b001001001;
	  end
      endcase // case ( State )
   end // always @ (State or ptext)   
endmodule // fsm
