module fsm_rd_091 (RST, CLK, ptext, rtext);
//user interface
	input RST, CLK;
	input [3:0] ptext;
	output[3:0] rtext;
	reg [3:0] rtext;
//STATE ASSIGNMENTS
	`include "fsm_rd_091_stassign.v";
   //process modeling state register
   always @ (posedge RST or posedge CLK) begin
      if( RST == 1) begin
	 State <= st_st1;
      end
      else
	State <= NextState;
   end
   always @ (State or ptext) begin
      case ( State )
	  st_st1: begin
		if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 1 )
 		  NextState <= st_st13;
		else if(ptext[1] == 1  && ptext[2] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[3] == 0 )
 		  NextState <= st_st2;
		else if(ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st13;
		else if(ptext[1] == 1  && ptext[3] == 0 )
 		  NextState <= st_st1;
		rtext <= 'b1000;
	  end
	  st_st2: begin
		if(1)
 		  NextState <= st_st3;
		rtext <= 'b0100;
	  end
	  st_st3: begin
		if(ptext[0] == 0  && ptext[3] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st3;
		else if(ptext[1] == 0  && ptext[3] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st3;
		rtext <= 'b1110;
	  end
	  st_st4: begin
		if(ptext[1] == 0  && ptext[3] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st31;
		else if(ptext[0] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1  && ptext[3] == 1 )
 		  NextState <= st_st31;
		rtext <= 'b1011;
	  end
	  st_st5: begin
		if(ptext[0] == 0  && ptext[2] == 0 )
 		  NextState <= st_st4;
		else if(ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st6;
		else if(ptext[3] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1  && ptext[3] == 1 )
 		  NextState <= st_st6;
		rtext <= 'b1101;
	  end
	  st_st6: begin
		if(ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st5;
		else if(ptext[0] == 0  && ptext[3] == 0 )
 		  NextState <= st_st7;
		else if(ptext[0] == 1 )
 		  NextState <= st_st5;
		else if(ptext[0] == 0  && ptext[2] == 0 )
 		  NextState <= st_st7;
		rtext <= 'b0111;
	  end
	  st_st7: begin
		if(ptext[0] == 0  && ptext[2] == 1 )
 		  NextState <= st_st8;
		else if(ptext[0] == 1  && ptext[1] == 0 )
 		  NextState <= st_st7;
		else if(ptext[1] == 1 )
 		  NextState <= st_st8;
		else if(ptext[1] == 0  && ptext[2] == 0 )
 		  NextState <= st_st7;
		rtext <= 'b0110;
	  end
	  st_st8: begin
		if(1)
 		  NextState <= st_st9;
		rtext <= 'b0111;
	  end
	  st_st9: begin
		if(ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st10;
		else if(ptext[0] == 0  && ptext[3] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1 )
 		  NextState <= st_st10;
		else if(ptext[0] == 0  && ptext[2] == 1 )
 		  NextState <= st_st9;
		rtext <= 'b0110;
	  end
	  st_st10: begin
		if(ptext[0] == 1  && ptext[2] == 1 )
 		  NextState <= st_st9;
		else if(ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st11;
		else if(ptext[3] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 0  && ptext[3] == 0 )
 		  NextState <= st_st11;
		rtext <= 'b1111;
	  end
	  st_st11: begin
		if(ptext[0] == 0  && ptext[3] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 1  && ptext[2] == 1 )
 		  NextState <= st_st11;
		else if(ptext[2] == 0 )
 		  NextState <= st_st12;
		else if(ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st11;
		rtext <= 'b0100;
	  end
	  st_st12: begin
		if(ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[2] == 1 )
 		  NextState <= st_st12;
		else if(ptext[0] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[3] == 0 )
 		  NextState <= st_st12;
		rtext <= 'b1100;
	  end
	  st_st13: begin
		if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st14;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st13;
		else if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0 )
 		  NextState <= st_st14;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0 )
 		  NextState <= st_st14;
		else if(ptext[0] == 0  && ptext[2] == 0 )
 		  NextState <= st_st13;
		rtext <= 'b0000;
	  end
	  st_st14: begin
		if(1)
 		  NextState <= st_st15;
		rtext <= 'b0110;
	  end
	  st_st15: begin
		if(1)
 		  NextState <= st_st16;
		rtext <= 'b0101;
	  end
	  st_st16: begin
		if(ptext[0] == 1  && ptext[2] == 0 )
 		  NextState <= st_st17;
		else if(ptext[1] == 0  && ptext[2] == 1 )
 		  NextState <= st_st16;
		else if(ptext[1] == 1 )
 		  NextState <= st_st17;
		else if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st16;
		rtext <= 'b1110;
	  end
	  st_st17: begin
		if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1 )
 		  NextState <= st_st18;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0 )
 		  NextState <= st_st24;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 0 )
 		  NextState <= st_st29;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0 )
 		  NextState <= st_st17;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st32;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 0 )
 		  NextState <= st_st33;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0 )
 		  NextState <= st_st24;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 1 )
 		  NextState <= st_st29;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st17;
		rtext <= 'b0110;
	  end
	  st_st18: begin
		if(1)
 		  NextState <= st_st19;
		rtext <= 'b0100;
	  end
	  st_st19: begin
		if(ptext[1] == 0  && ptext[3] == 0 )
 		  NextState <= st_st18;
		else if(ptext[1] == 1  && ptext[2] == 0 )
 		  NextState <= st_st20;
		else if(ptext[2] == 1 )
 		  NextState <= st_st18;
		else if(ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st20;
		rtext <= 'b1111;
	  end
	  st_st20: begin
		if(1)
 		  NextState <= st_st21;
		rtext <= 'b0011;
	  end
	  st_st21: begin
		if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st20;
		else if(ptext[1] == 1  && ptext[3] == 1 )
 		  NextState <= st_st22;
		else if(ptext[3] == 0 )
 		  NextState <= st_st20;
		else if(ptext[0] == 1  && ptext[3] == 1 )
 		  NextState <= st_st22;
		rtext <= 'b1000;
	  end
	  st_st22: begin
		if(ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st23;
		else if(ptext[0] == 0  && ptext[2] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 1 )
 		  NextState <= st_st23;
		else if(ptext[0] == 0  && ptext[3] == 0 )
 		  NextState <= st_st22;
		rtext <= 'b1001;
	  end
	  st_st23: begin
		if(1)
 		  NextState <= st_st1;
		rtext <= 'b1111;
	  end
	  st_st24: begin
		if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st17;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st25;
		else if(ptext[0] == 0  && ptext[2] == 1 )
 		  NextState <= st_st24;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st60;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st25;
		else if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st24;
		else if(ptext[0] == 1  && ptext[2] == 1 )
 		  NextState <= st_st60;
		rtext <= 'b0001;
	  end
	  st_st25: begin
		if(1)
 		  NextState <= st_st26;
		rtext <= 'b0011;
	  end
	  st_st26: begin
		if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st25;
		else if(ptext[0] == 0  && ptext[3] == 0 )
 		  NextState <= st_st27;
		else if(ptext[3] == 1 )
 		  NextState <= st_st25;
		else if(ptext[1] == 0  && ptext[3] == 0 )
 		  NextState <= st_st27;
		rtext <= 'b1001;
	  end
	  st_st27: begin
		if(ptext[1] == 0  && ptext[3] == 0 )
 		  NextState <= st_st26;
		else if(ptext[1] == 1  && ptext[2] == 0 )
 		  NextState <= st_st28;
		else if(ptext[2] == 1 )
 		  NextState <= st_st26;
		else if(ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st28;
		rtext <= 'b1110;
	  end
	  st_st28: begin
		if(ptext[0] == 1  && ptext[1] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 0  && ptext[2] == 1 )
 		  NextState <= st_st28;
		else if(ptext[2] == 0 )
 		  NextState <= st_st4;
		else if(ptext[1] == 1  && ptext[2] == 1 )
 		  NextState <= st_st28;
		rtext <= 'b0100;
	  end
	  st_st29: begin
		if(1)
 		  NextState <= st_st30;
		rtext <= 'b0111;
	  end
	  st_st30: begin
		if(ptext[0] == 1  && ptext[3] == 1 )
 		  NextState <= st_st29;
		else if(ptext[0] == 0  && ptext[2] == 0 )
 		  NextState <= st_st31;
		else if(ptext[2] == 1 )
 		  NextState <= st_st29;
		else if(ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st31;
		rtext <= 'b1111;
	  end
	  st_st31: begin
		if(1)
 		  NextState <= st_st4;
		rtext <= 'b1101;
	  end
	  st_st32: begin
		if(ptext[0] == 0  && ptext[2] == 0 )
 		  NextState <= st_st17;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1 )
 		  NextState <= st_st32;
		else if(ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st17;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[3] == 1 )
 		  NextState <= st_st32;
		rtext <= 'b0101;
	  end
	  st_st33: begin
		if(1)
 		  NextState <= st_st34;
		rtext <= 'b0000;
	  end
	  st_st34: begin
		if(ptext[0] == 0  && ptext[3] == 1 )
 		  NextState <= st_st35;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0 )
 		  NextState <= st_st37;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st52;
		else if(ptext[1] == 0  && ptext[3] == 1 )
 		  NextState <= st_st35;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0 )
 		  NextState <= st_st37;
		else if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st52;
		rtext <= 'b0110;
	  end
	  st_st35: begin
		if(1)
 		  NextState <= st_st36;
		rtext <= 'b0011;
	  end
	  st_st36: begin
		if(ptext[0] == 1  && ptext[2] == 0 )
 		  NextState <= st_st35;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 1 )
 		  NextState <= st_st36;
		else if(ptext[1] == 0  && ptext[2] == 1 )
 		  NextState <= st_st35;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[2] == 1 )
 		  NextState <= st_st36;
		rtext <= 'b1010;
	  end
	  st_st37: begin
		if(ptext[0] == 1  && ptext[2] == 1 )
 		  NextState <= st_st34;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st38;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1 )
 		  NextState <= st_st37;
		else if(ptext[0] == 1  && ptext[3] == 0 )
 		  NextState <= st_st34;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1 )
 		  NextState <= st_st38;
		else if(ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st37;
		rtext <= 'b1010;
	  end
	  st_st38: begin
		if(1)
 		  NextState <= st_st39;
		rtext <= 'b1101;
	  end
	  st_st39: begin
		if(ptext[1] == 0  && ptext[3] == 0 )
 		  NextState <= st_st38;
		else if(ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st40;
		else if(ptext[2] == 0 )
 		  NextState <= st_st38;
		else if(ptext[1] == 1  && ptext[2] == 1 )
 		  NextState <= st_st40;
		rtext <= 'b1001;
	  end
	  st_st40: begin
		if(ptext[0] == 1  && ptext[3] == 1 )
 		  NextState <= st_st39;
		else if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st41;
		else if(ptext[1] == 1 )
 		  NextState <= st_st39;
		else if(ptext[1] == 0  && ptext[3] == 0 )
 		  NextState <= st_st41;
		rtext <= 'b0101;
	  end
	  st_st41: begin
		if(ptext[2] == 1  && ptext[3] == 0 )
 		  NextState <= st_st42;
		else if(ptext[0] == 0  && ptext[3] == 1 )
 		  NextState <= st_st41;
		else if(ptext[0] == 1 )
 		  NextState <= st_st42;
		else if(ptext[0] == 0  && ptext[2] == 0 )
 		  NextState <= st_st41;
		rtext <= 'b0000;
	  end
	  st_st42: begin
		if(1)
 		  NextState <= st_st43;
		rtext <= 'b0101;
	  end
	  st_st43: begin
		if(ptext[2] == 1  && ptext[3] == 0 )
 		  NextState <= st_st44;
		else if(ptext[1] == 1  && ptext[2] == 0 )
 		  NextState <= st_st43;
		else if(ptext[1] == 0 )
 		  NextState <= st_st44;
		else if(ptext[1] == 1  && ptext[3] == 1 )
 		  NextState <= st_st43;
		rtext <= 'b1101;
	  end
	  st_st44: begin
		if(ptext[1] == 0  && ptext[2] == 1 )
 		  NextState <= st_st43;
		else if(ptext[0] == 1  && ptext[2] == 0 )
 		  NextState <= st_st45;
		else if(ptext[0] == 0 )
 		  NextState <= st_st43;
		else if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st45;
		rtext <= 'b1001;
	  end
	  st_st45: begin
		if(ptext[0] == 1  && ptext[1] == 0 )
 		  NextState <= st_st46;
		else if(ptext[0] == 0  && ptext[3] == 0 )
 		  NextState <= st_st45;
		else if(ptext[3] == 1 )
 		  NextState <= st_st46;
		else if(ptext[1] == 1  && ptext[3] == 0 )
 		  NextState <= st_st45;
		rtext <= 'b0011;
	  end
	  st_st46: begin
		if(ptext[2] == 1  && ptext[3] == 0 )
 		  NextState <= st_st47;
		else if(ptext[0] == 0  && ptext[3] == 1 )
 		  NextState <= st_st46;
		else if(ptext[0] == 1 )
 		  NextState <= st_st47;
		else if(ptext[0] == 0  && ptext[2] == 0 )
 		  NextState <= st_st46;
		rtext <= 'b1110;
	  end
	  st_st47: begin
		if(ptext[0] == 0  && ptext[3] == 0 )
 		  NextState <= st_st48;
		else if(ptext[1] == 1  && ptext[3] == 1 )
 		  NextState <= st_st47;
		else if(ptext[1] == 0 )
 		  NextState <= st_st48;
		else if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st47;
		rtext <= 'b0101;
	  end
	  st_st48: begin
		if(1)
 		  NextState <= st_st49;
		rtext <= 'b0101;
	  end
	  st_st49: begin
		if(ptext[1] == 1  && ptext[2] == 0 )
 		  NextState <= st_st48;
		else if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st50;
		else if(ptext[0] == 1 )
 		  NextState <= st_st48;
		else if(ptext[0] == 0  && ptext[2] == 1 )
 		  NextState <= st_st50;
		rtext <= 'b1100;
	  end
	  st_st50: begin
		if(ptext[0] == 1  && ptext[2] == 0 )
 		  NextState <= st_st49;
		else if(ptext[1] == 0  && ptext[2] == 1 )
 		  NextState <= st_st51;
		else if(ptext[1] == 1 )
 		  NextState <= st_st49;
		else if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st51;
		rtext <= 'b1001;
	  end
	  st_st51: begin
		if(1)
 		  NextState <= st_st24;
		rtext <= 'b0011;
	  end
	  st_st52: begin
		if(1)
 		  NextState <= st_st53;
		rtext <= 'b0100;
	  end
	  st_st53: begin
		if(ptext[1] == 0  && ptext[3] == 0 )
 		  NextState <= st_st52;
		else if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st54;
		else if(ptext[0] == 1 )
 		  NextState <= st_st52;
		else if(ptext[0] == 0  && ptext[3] == 1 )
 		  NextState <= st_st54;
		rtext <= 'b0010;
	  end
	  st_st54: begin
		if(1)
 		  NextState <= st_st55;
		rtext <= 'b1010;
	  end
	  st_st55: begin
		if(ptext[0] == 0  && ptext[3] == 1 )
 		  NextState <= st_st54;
		else if(ptext[1] == 1  && ptext[3] == 0 )
 		  NextState <= st_st56;
		else if(ptext[1] == 0 )
 		  NextState <= st_st54;
		else if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st56;
		rtext <= 'b0111;
	  end
	  st_st56: begin
		if(ptext[0] == 0  && ptext[2] == 0 )
 		  NextState <= st_st57;
		else if(ptext[2] == 1  && ptext[3] == 0 )
 		  NextState <= st_st56;
		else if(ptext[3] == 1 )
 		  NextState <= st_st57;
		else if(ptext[0] == 1  && ptext[3] == 0 )
 		  NextState <= st_st56;
		rtext <= 'b1011;
	  end
	  st_st57: begin
		if(1)
 		  NextState <= st_st58;
		rtext <= 'b1011;
	  end
	  st_st58: begin
		if(1)
 		  NextState <= st_st59;
		rtext <= 'b0001;
	  end
	  st_st59: begin
		if(ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st58;
		else if(ptext[0] == 0  && ptext[2] == 1 )
 		  NextState <= st_st60;
		else if(ptext[0] == 1 )
 		  NextState <= st_st58;
		else if(ptext[0] == 0  && ptext[3] == 1 )
 		  NextState <= st_st60;
		rtext <= 'b0000;
	  end
	  st_st60: begin
		if(1)
 		  NextState <= st_st24;
		rtext <= 'b0000;
	  end
      endcase // case ( State )
   end // always @ (State or ptext)   
endmodule // fsm
