module fsm_rd_097 (RST, CLK, ptext, rtext);
//user interface
	input RST, CLK;
	input [15:0] ptext;
	output[3:0] rtext;
	reg [3:0] rtext;
//STATE ASSIGNMENTS
	`include "fsm_rd_097_stassign.v";
   //process modeling state register
   always @ (posedge RST or posedge CLK) begin
      if( RST == 1) begin
	 State <= st_st1;
      end
      else
	State <= NextState;
   end
   always @ (State or ptext) begin
      case ( State )
	  st_st1: begin
		if(1)
 		  NextState <= st_st2;
		rtext <= 'b1001;
	  end
	  st_st2: begin
		if(ptext[2] == 1  && ptext[6] == 0  && ptext[12] == 1  && ptext[13] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[8] == 1  && ptext[13] == 1  && ptext[15] == 1 )
 		  NextState <= st_st2;
		else if(ptext[2] == 1  && ptext[8] == 0  && ptext[12] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[2] == 1 )
 		  NextState <= st_st3;
		else if(ptext[15] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[6] == 1  && ptext[8] == 1  && ptext[15] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[12] == 0  && ptext[15] == 1 )
 		  NextState <= st_st2;
		else if(ptext[2] == 0  && ptext[15] == 1 )
 		  NextState <= st_st2;
		rtext <= 'b1110;
	  end
	  st_st3: begin
		if(1)
 		  NextState <= st_st4;
		rtext <= 'b1011;
	  end
	  st_st4: begin
		if(ptext[3] == 1  && ptext[9] == 1  && ptext[12] == 0  && ptext[13] == 0 )
 		  NextState <= st_st5;
		else if(ptext[3] == 0  && ptext[6] == 1  && ptext[10] == 1  && ptext[15] == 0 )
 		  NextState <= st_st4;
		else if(ptext[9] == 1  && ptext[10] == 0  && ptext[13] == 0 )
 		  NextState <= st_st5;
		else if(ptext[9] == 1  && ptext[15] == 1 )
 		  NextState <= st_st5;
		else if(ptext[6] == 0 )
 		  NextState <= st_st5;
		else if(ptext[6] == 1  && ptext[10] == 1  && ptext[12] == 1  && ptext[15] == 0 )
 		  NextState <= st_st4;
		else if(ptext[6] == 1  && ptext[13] == 1  && ptext[15] == 0 )
 		  NextState <= st_st4;
		else if(ptext[6] == 1  && ptext[9] == 0 )
 		  NextState <= st_st4;
		rtext <= 'b0000;
	  end
	  st_st5: begin
		if(1)
 		  NextState <= st_st6;
		rtext <= 'b0111;
	  end
	  st_st6: begin
		if(1)
 		  NextState <= st_st7;
		rtext <= 'b0101;
	  end
	  st_st7: begin
		if(1)
 		  NextState <= st_st8;
		rtext <= 'b0001;
	  end
	  st_st8: begin
		if(ptext[0] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[7] == 1  && ptext[9] == 1  && ptext[15] == 1 )
 		  NextState <= st_st9;
		else if(ptext[3] == 0  && ptext[5] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 0  && ptext[12] == 1 )
 		  NextState <= st_st8;
		else if(ptext[0] == 1  && ptext[5] == 0  && ptext[7] == 0  && ptext[8] == 0  && ptext[12] == 1  && ptext[15] == 1 )
 		  NextState <= st_st19;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[7] == 0  && ptext[9] == 1  && ptext[12] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[8] == 1  && ptext[12] == 1 )
 		  NextState <= st_st9;
		else if(ptext[5] == 1  && ptext[12] == 1 )
 		  NextState <= st_st9;
		else if(ptext[3] == 0  && ptext[7] == 1  && ptext[9] == 1  && ptext[12] == 0  && ptext[15] == 0 )
 		  NextState <= st_st8;
		else if(ptext[3] == 0  && ptext[5] == 0  && ptext[8] == 0  && ptext[12] == 1  && ptext[15] == 0 )
 		  NextState <= st_st8;
		else if(ptext[0] == 0  && ptext[9] == 1  && ptext[12] == 0 )
 		  NextState <= st_st8;
		else if(ptext[0] == 0  && ptext[5] == 0  && ptext[12] == 1 )
 		  NextState <= st_st8;
		else if(ptext[0] == 1  && ptext[5] == 1  && ptext[7] == 1  && ptext[12] == 0  && ptext[15] == 1 )
 		  NextState <= st_st19;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[5] == 0 )
 		  NextState <= st_st19;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[12] == 0 )
 		  NextState <= st_st19;
		else if(ptext[9] == 0  && ptext[12] == 0 )
 		  NextState <= st_st19;
		rtext <= 'b0000;
	  end
	  st_st9: begin
		if(ptext[2] == 1  && ptext[6] == 1  && ptext[9] == 0  && ptext[11] == 1 )
 		  NextState <= st_st8;
		else if(ptext[0] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[9] == 1 )
 		  NextState <= st_st10;
		else if(ptext[2] == 1  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st8;
		else if(ptext[2] == 1  && ptext[8] == 1 )
 		  NextState <= st_st8;
		else if(ptext[0] == 1 )
 		  NextState <= st_st8;
		else if(ptext[0] == 0  && ptext[7] == 1  && ptext[8] == 0  && ptext[11] == 0 )
 		  NextState <= st_st10;
		else if(ptext[0] == 0  && ptext[6] == 0  && ptext[8] == 0 )
 		  NextState <= st_st10;
		else if(ptext[0] == 0  && ptext[2] == 0 )
 		  NextState <= st_st10;
		rtext <= 'b0111;
	  end
	  st_st10: begin
		if(1)
 		  NextState <= st_st11;
		rtext <= 'b0001;
	  end
	  st_st11: begin
		if(1)
 		  NextState <= st_st12;
		rtext <= 'b1001;
	  end
	  st_st12: begin
		if(ptext[0] == 0  && ptext[4] == 1  && ptext[5] == 1  && ptext[7] == 0  && ptext[9] == 1  && ptext[15] == 0 )
 		  NextState <= st_st11;
		else if(ptext[4] == 0  && ptext[6] == 1  && ptext[7] == 0  && ptext[9] == 1  && ptext[10] == 1  && ptext[15] == 0 )
 		  NextState <= st_st13;
		else if(ptext[0] == 0  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[10] == 1  && ptext[15] == 1 )
 		  NextState <= st_st12;
		else if(ptext[4] == 1  && ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[10] == 1  && ptext[15] == 0 )
 		  NextState <= st_st11;
		else if(ptext[5] == 1  && ptext[7] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 1  && ptext[4] == 1  && ptext[6] == 1  && ptext[7] == 1  && ptext[15] == 0 )
 		  NextState <= st_st11;
		else if(ptext[6] == 0  && ptext[7] == 0 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0  && ptext[4] == 1  && ptext[5] == 0  && ptext[6] == 1 )
 		  NextState <= st_st13;
		else if(ptext[0] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st13;
		else if(ptext[4] == 1  && ptext[7] == 1  && ptext[15] == 1 )
 		  NextState <= st_st13;
		else if(ptext[5] == 0  && ptext[6] == 1  && ptext[7] == 0 )
 		  NextState <= st_st13;
		else if(ptext[0] == 0  && ptext[5] == 1  && ptext[7] == 1  && ptext[10] == 0  && ptext[15] == 0 )
 		  NextState <= st_st12;
		else if(ptext[6] == 0  && ptext[7] == 1  && ptext[15] == 0 )
 		  NextState <= st_st12;
		else if(ptext[5] == 1  && ptext[6] == 1  && ptext[7] == 0  && ptext[9] == 0 )
 		  NextState <= st_st12;
		else if(ptext[4] == 0  && ptext[7] == 1 )
 		  NextState <= st_st12;
		rtext <= 'b1001;
	  end
	  st_st13: begin
		if(ptext[3] == 0  && ptext[8] == 1  && ptext[9] == 0  && ptext[13] == 1 )
 		  NextState <= st_st14;
		else if(ptext[5] == 1  && ptext[6] == 0  && ptext[9] == 1  && ptext[14] == 1 )
 		  NextState <= st_st13;
		else if(ptext[3] == 0  && ptext[13] == 1  && ptext[14] == 0 )
 		  NextState <= st_st14;
		else if(ptext[5] == 0  && ptext[13] == 1 )
 		  NextState <= st_st14;
		else if(ptext[6] == 1 )
 		  NextState <= st_st14;
		else if(ptext[5] == 1  && ptext[6] == 0  && ptext[8] == 0  && ptext[14] == 1 )
 		  NextState <= st_st13;
		else if(ptext[3] == 1  && ptext[5] == 1  && ptext[6] == 0 )
 		  NextState <= st_st13;
		else if(ptext[6] == 0  && ptext[13] == 0 )
 		  NextState <= st_st13;
		rtext <= 'b0111;
	  end
	  st_st14: begin
		if(ptext[1] == 1  && ptext[5] == 1  && ptext[9] == 1  && ptext[15] == 0 )
 		  NextState <= st_st15;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[10] == 0  && ptext[13] == 0 )
 		  NextState <= st_st14;
		else if(ptext[5] == 1  && ptext[9] == 1  && ptext[13] == 1 )
 		  NextState <= st_st15;
		else if(ptext[9] == 1  && ptext[10] == 1 )
 		  NextState <= st_st15;
		else if(ptext[2] == 0 )
 		  NextState <= st_st15;
		else if(ptext[2] == 1  && ptext[10] == 0  && ptext[13] == 0  && ptext[15] == 1 )
 		  NextState <= st_st14;
		else if(ptext[2] == 1  && ptext[5] == 0  && ptext[10] == 0 )
 		  NextState <= st_st14;
		else if(ptext[2] == 1  && ptext[9] == 0 )
 		  NextState <= st_st14;
		rtext <= 'b0110;
	  end
	  st_st15: begin
		if(ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st14;
		else if(ptext[2] == 1  && ptext[6] == 0  && ptext[10] == 0  && ptext[14] == 0 )
 		  NextState <= st_st16;
		else if(ptext[3] == 1  && ptext[4] == 1  && ptext[6] == 1 )
 		  NextState <= st_st14;
		else if(ptext[4] == 1  && ptext[10] == 1 )
 		  NextState <= st_st14;
		else if(ptext[14] == 1 )
 		  NextState <= st_st14;
		else if(ptext[5] == 1  && ptext[6] == 0  && ptext[10] == 0  && ptext[14] == 0 )
 		  NextState <= st_st16;
		else if(ptext[3] == 0  && ptext[10] == 0  && ptext[14] == 0 )
 		  NextState <= st_st16;
		else if(ptext[4] == 0  && ptext[14] == 0 )
 		  NextState <= st_st16;
		rtext <= 'b0010;
	  end
	  st_st16: begin
		if(1)
 		  NextState <= st_st17;
		rtext <= 'b1111;
	  end
	  st_st17: begin
		if(1)
 		  NextState <= st_st18;
		rtext <= 'b1110;
	  end
	  st_st18: begin
		if(ptext[4] == 0  && ptext[5] == 1  && ptext[7] == 0  && ptext[15] == 1 )
 		  NextState <= st_st1;
		else if(ptext[8] == 1  && ptext[12] == 1  && ptext[14] == 0  && ptext[15] == 0 )
 		  NextState <= st_st18;
		else if(ptext[4] == 0  && ptext[5] == 1  && ptext[14] == 1 )
 		  NextState <= st_st1;
		else if(ptext[5] == 1  && ptext[8] == 0 )
 		  NextState <= st_st1;
		else if(ptext[12] == 0 )
 		  NextState <= st_st1;
		else if(ptext[7] == 1  && ptext[8] == 1  && ptext[12] == 1  && ptext[14] == 0 )
 		  NextState <= st_st18;
		else if(ptext[4] == 1  && ptext[8] == 1  && ptext[12] == 1 )
 		  NextState <= st_st18;
		else if(ptext[5] == 0  && ptext[12] == 1 )
 		  NextState <= st_st18;
		rtext <= 'b1101;
	  end
	  st_st19: begin
		if(ptext[0] == 0  && ptext[4] == 0  && ptext[7] == 1  && ptext[9] == 1 )
 		  NextState <= st_st8;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[12] == 1 )
 		  NextState <= st_st20;
		else if(ptext[3] == 1  && ptext[4] == 0  && ptext[9] == 1 )
 		  NextState <= st_st8;
		else if(ptext[1] == 1  && ptext[4] == 0 )
 		  NextState <= st_st8;
		else if(ptext[12] == 0 )
 		  NextState <= st_st8;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[7] == 0  && ptext[12] == 1 )
 		  NextState <= st_st20;
		else if(ptext[1] == 0  && ptext[9] == 0  && ptext[12] == 1 )
 		  NextState <= st_st20;
		else if(ptext[4] == 1  && ptext[12] == 1 )
 		  NextState <= st_st20;
		rtext <= 'b1001;
	  end
	  st_st20: begin
		if(1)
 		  NextState <= st_st21;
		rtext <= 'b1010;
	  end
	  st_st21: begin
		if(ptext[0] == 0  && ptext[2] == 1  && ptext[8] == 0  && ptext[11] == 0 )
 		  NextState <= st_st22;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[12] == 0  && ptext[13] == 0 )
 		  NextState <= st_st21;
		else if(ptext[2] == 1  && ptext[8] == 0  && ptext[12] == 1 )
 		  NextState <= st_st22;
		else if(ptext[1] == 0  && ptext[8] == 0 )
 		  NextState <= st_st22;
		else if(ptext[13] == 1 )
 		  NextState <= st_st22;
		else if(ptext[1] == 1  && ptext[11] == 1  && ptext[12] == 0  && ptext[13] == 0 )
 		  NextState <= st_st21;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[13] == 0 )
 		  NextState <= st_st21;
		else if(ptext[8] == 1  && ptext[13] == 0 )
 		  NextState <= st_st21;
		rtext <= 'b1011;
	  end
	  st_st22: begin
		if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[8] == 0 )
 		  NextState <= st_st23;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[5] == 0  && ptext[13] == 1 )
 		  NextState <= st_st26;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[5] == 0  && ptext[8] == 0  && ptext[13] == 1 )
 		  NextState <= st_st22;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1  && ptext[5] == 0  && ptext[8] == 0 )
 		  NextState <= st_st23;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0  && ptext[13] == 0 )
 		  NextState <= st_st23;
		else if(ptext[4] == 0  && ptext[5] == 1 )
 		  NextState <= st_st23;
		else if(ptext[3] == 0  && ptext[4] == 0  && ptext[5] == 0  && ptext[8] == 1  && ptext[13] == 1 )
 		  NextState <= st_st26;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1  && ptext[5] == 0 )
 		  NextState <= st_st26;
		else if(ptext[2] == 1  && ptext[4] == 1  && ptext[8] == 1 )
 		  NextState <= st_st26;
		else if(ptext[1] == 0  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st26;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 1  && ptext[8] == 0 )
 		  NextState <= st_st22;
		else if(ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 0  && ptext[5] == 0 )
 		  NextState <= st_st22;
		else if(ptext[4] == 1  && ptext[5] == 1  && ptext[8] == 0 )
 		  NextState <= st_st22;
		else if(ptext[2] == 0  && ptext[4] == 1 )
 		  NextState <= st_st22;
		rtext <= 'b0000;
	  end
	  st_st23: begin
		if(ptext[5] == 0  && ptext[9] == 1  && ptext[10] == 0  && ptext[12] == 0 )
 		  NextState <= st_st24;
		else if(ptext[1] == 1  && ptext[4] == 1  && ptext[5] == 1  && ptext[15] == 1 )
 		  NextState <= st_st23;
		else if(ptext[4] == 0  && ptext[9] == 1  && ptext[10] == 0 )
 		  NextState <= st_st24;
		else if(ptext[10] == 0  && ptext[15] == 0 )
 		  NextState <= st_st24;
		else if(ptext[1] == 0 )
 		  NextState <= st_st24;
		else if(ptext[1] == 1  && ptext[4] == 1  && ptext[12] == 1  && ptext[15] == 1 )
 		  NextState <= st_st23;
		else if(ptext[1] == 1  && ptext[9] == 0  && ptext[15] == 1 )
 		  NextState <= st_st23;
		else if(ptext[1] == 1  && ptext[10] == 1 )
 		  NextState <= st_st23;
		rtext <= 'b1000;
	  end
	  st_st24: begin
		if(1)
 		  NextState <= st_st25;
		rtext <= 'b0111;
	  end
	  st_st25: begin
		if(ptext[0] == 0  && ptext[11] == 1  && ptext[13] == 1  && ptext[15] == 1 )
 		  NextState <= st_st1;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[8] == 1  && ptext[13] == 0 )
 		  NextState <= st_st25;
		else if(ptext[0] == 0  && ptext[8] == 0  && ptext[11] == 1 )
 		  NextState <= st_st1;
		else if(ptext[3] == 0  && ptext[11] == 1 )
 		  NextState <= st_st1;
		else if(ptext[2] == 0 )
 		  NextState <= st_st1;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[8] == 1  && ptext[15] == 0 )
 		  NextState <= st_st25;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st25;
		else if(ptext[2] == 1  && ptext[11] == 0 )
 		  NextState <= st_st25;
		rtext <= 'b1011;
	  end
	  st_st26: begin
		if(1)
 		  NextState <= st_st27;
		rtext <= 'b1111;
	  end
	  st_st27: begin
		if(1)
 		  NextState <= st_st1;
		rtext <= 'b1111;
	  end
      endcase // case ( State )
   end // always @ (State or ptext)   
endmodule // fsm
