module fsm_rd_099 (RST, CLK, ptext, rtext);
//user interface
	input RST, CLK;
	input [4:0] ptext;
	output[10:0] rtext;
	reg [10:0] rtext;
//STATE ASSIGNMENTS
	`include "fsm_rd_099_stassign.v";
   //process modeling state register
   always @ (posedge RST or posedge CLK) begin
      if( RST == 1) begin
	 State <= st_st1;
      end
      else
	State <= NextState;
   end
   always @ (State or ptext) begin
      case ( State )
	  st_st1: begin
		if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st2;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st6;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1 )
 		  NextState <= st_st7;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st4;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0 )
 		  NextState <= st_st4;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 1 )
 		  NextState <= st_st6;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 0 )
 		  NextState <= st_st7;
		rtext <= 'b11111100000;
	  end
	  st_st2: begin
		if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0 )
 		  NextState <= st_st9;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 0 )
 		  NextState <= st_st13;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0 )
 		  NextState <= st_st15;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st9;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st12;
		else if(ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st13;
		else if(ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st15;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 0 )
 		  NextState <= st_st3;
		rtext <= 'b00011110001;
	  end
	  st_st3: begin
		if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st8;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st10;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st13;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st14;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st16;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st21;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st23;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st25;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st26;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st27;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st29;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st13;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st13;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st30;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st31;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st33;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st35;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st8;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st10;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st12;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st13;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st14;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st16;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st21;
		rtext <= 'b10001000101;
	  end
	  st_st4: begin
		if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1 )
 		  NextState <= st_st1;
		else if(ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 1  && ptext[3] == 1 )
 		  NextState <= st_st1;
		else if(ptext[4] == 1 )
 		  NextState <= st_st1;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st5;
		else if(ptext[0] == 0  && ptext[4] == 0 )
 		  NextState <= st_st5;
		rtext <= 'b11011000100;
	  end
	  st_st5: begin
		if(ptext[0] == 1  && ptext[2] == 0  && ptext[4] == 1 )
 		  NextState <= st_st4;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 0 )
 		  NextState <= st_st1;
		else if(ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st4;
		else if(ptext[1] == 1 )
 		  NextState <= st_st4;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st1;
		else if(ptext[1] == 0  && ptext[2] == 1 )
 		  NextState <= st_st1;
		rtext <= 'b00010010000;
	  end
	  st_st6: begin
		if(1)
 		  NextState <= st_st7;
		rtext <= 'b01100110101;
	  end
	  st_st7: begin
		if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st6;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[4] == 1 )
 		  NextState <= st_st7;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st6;
		else if(ptext[0] == 0  && ptext[4] == 0 )
 		  NextState <= st_st6;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 0 )
 		  NextState <= st_st1;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0 )
 		  NextState <= st_st7;
		else if(ptext[1] == 1  && ptext[4] == 1 )
 		  NextState <= st_st7;
		rtext <= 'b11101001000;
	  end
	  st_st8: begin
		if(ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[1] == 0 )
 		  NextState <= st_st3;
		else if(ptext[2] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st9;
		else if(ptext[1] == 1  && ptext[2] == 0 )
 		  NextState <= st_st9;
		rtext <= 'b01001110110;
	  end
	  st_st9: begin
		if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st18;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st38;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st41;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st42;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[4] == 1 )
 		  NextState <= st_st18;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0 )
 		  NextState <= st_st38;
		else if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st41;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st42;
		rtext <= 'b01100110111;
	  end
	  st_st10: begin
		if(ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[4] == 0 )
 		  NextState <= st_st11;
		else if(ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0  && ptext[3] == 0 )
 		  NextState <= st_st11;
		rtext <= 'b00101101000;
	  end
	  st_st11: begin
		if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 1 )
 		  NextState <= st_st17;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st19;
		else if(ptext[2] == 1  && ptext[4] == 0 )
 		  NextState <= st_st2;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st17;
		else if(ptext[0] == 0  && ptext[2] == 0 )
 		  NextState <= st_st17;
		else if(ptext[0] == 1  && ptext[2] == 0 )
 		  NextState <= st_st19;
		rtext <= 'b00001010001;
	  end
	  st_st12: begin
		if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st3;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1 )
 		  NextState <= st_st12;
		else if(ptext[0] == 1  && ptext[1] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 0  && ptext[1] == 0 )
 		  NextState <= st_st12;
		rtext <= 'b10101100010;
	  end
	  st_st13: begin
		if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st22;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0 )
 		  NextState <= st_st25;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0 )
 		  NextState <= st_st26;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st28;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st30;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st32;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st36;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st22;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st25;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 1 )
 		  NextState <= st_st28;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st3;
		rtext <= 'b00100001111;
	  end
	  st_st14: begin
		if(1)
 		  NextState <= st_st15;
		rtext <= 'b11001100111;
	  end
	  st_st15: begin
		if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0 )
 		  NextState <= st_st14;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0 )
 		  NextState <= st_st2;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st15;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st37;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st39;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st41;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 1 )
 		  NextState <= st_st42;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st15;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 1 )
 		  NextState <= st_st37;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 0 )
 		  NextState <= st_st39;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st41;
		rtext <= 'b11100100010;
	  end
	  st_st16: begin
		if(ptext[1] == 1  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 1 )
 		  NextState <= st_st2;
		else if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st3;
		else if(ptext[2] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st2;
		else if(ptext[1] == 0  && ptext[2] == 0 )
 		  NextState <= st_st2;
		rtext <= 'b10011100010;
	  end
	  st_st17: begin
		if(ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1 )
 		  NextState <= st_st18;
		else if(ptext[1] == 1  && ptext[4] == 1 )
 		  NextState <= st_st11;
		else if(ptext[0] == 1 )
 		  NextState <= st_st11;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0 )
 		  NextState <= st_st18;
		else if(ptext[0] == 0  && ptext[4] == 0 )
 		  NextState <= st_st18;
		rtext <= 'b00111101000;
	  end
	  st_st18: begin
		if(ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1 )
 		  NextState <= st_st18;
		else if(ptext[0] == 1  && ptext[4] == 0 )
 		  NextState <= st_st9;
		else if(ptext[3] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st18;
		else if(ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st18;
		rtext <= 'b10100001010;
	  end
	  st_st19: begin
		if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 1 )
 		  NextState <= st_st11;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st20;
		else if(ptext[0] == 1  && ptext[3] == 0 )
 		  NextState <= st_st11;
		else if(ptext[2] == 0 )
 		  NextState <= st_st11;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st20;
		else if(ptext[0] == 0  && ptext[2] == 1 )
 		  NextState <= st_st20;
		rtext <= 'b10100010110;
	  end
	  st_st20: begin
		if(1)
 		  NextState <= st_st9;
		rtext <= 'b10001010010;
	  end
	  st_st21: begin
		if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 0 )
 		  NextState <= st_st22;
		else if(ptext[1] == 1  && ptext[2] == 0 )
 		  NextState <= st_st3;
		else if(ptext[3] == 1 )
 		  NextState <= st_st3;
		else if(ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st22;
		else if(ptext[1] == 0  && ptext[3] == 0 )
 		  NextState <= st_st22;
		rtext <= 'b01001011011;
	  end
	  st_st22: begin
		if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st13;
		else if(ptext[0] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st22;
		else if(ptext[0] == 1  && ptext[1] == 1 )
 		  NextState <= st_st13;
		else if(ptext[4] == 0 )
 		  NextState <= st_st13;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[4] == 1 )
 		  NextState <= st_st22;
		else if(ptext[1] == 0  && ptext[4] == 1 )
 		  NextState <= st_st22;
		rtext <= 'b00000100001;
	  end
	  st_st23: begin
		if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 0 )
 		  NextState <= st_st3;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 1 )
 		  NextState <= st_st24;
		else if(ptext[2] == 1  && ptext[3] == 0 )
 		  NextState <= st_st3;
		else if(ptext[4] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 1 )
 		  NextState <= st_st24;
		else if(ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st24;
		rtext <= 'b10100101110;
	  end
	  st_st24: begin
		if(1)
 		  NextState <= st_st13;
		rtext <= 'b11100000110;
	  end
	  st_st25: begin
		if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0 )
 		  NextState <= st_st13;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 0 )
 		  NextState <= st_st25;
		else if(ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st3;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st13;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 0 )
 		  NextState <= st_st13;
		else if(ptext[0] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st25;
		else if(ptext[1] == 1  && ptext[3] == 0 )
 		  NextState <= st_st25;
		rtext <= 'b10000100101;
	  end
	  st_st26: begin
		if(ptext[0] == 1  && ptext[2] == 1  && ptext[4] == 0 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 0 )
 		  NextState <= st_st13;
		else if(ptext[1] == 0  && ptext[4] == 0 )
 		  NextState <= st_st3;
		else if(ptext[3] == 1 )
 		  NextState <= st_st3;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st13;
		else if(ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st13;
		rtext <= 'b01110101000;
	  end
	  st_st27: begin
		if(1)
 		  NextState <= st_st28;
		rtext <= 'b10011000010;
	  end
	  st_st28: begin
		if(ptext[0] == 1  && ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st27;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 0 )
 		  NextState <= st_st13;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st28;
		else if(ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st27;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st13;
		else if(ptext[0] == 0  && ptext[3] == 0 )
 		  NextState <= st_st13;
		else if(ptext[0] == 1  && ptext[3] == 0 )
 		  NextState <= st_st28;
		rtext <= 'b01010011100;
	  end
	  st_st29: begin
		if(ptext[0] == 1  && ptext[1] == 1  && ptext[4] == 0 )
 		  NextState <= st_st3;
		else if(ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st13;
		else if(ptext[0] == 1  && ptext[2] == 1 )
 		  NextState <= st_st3;
		else if(ptext[3] == 0 )
 		  NextState <= st_st3;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st13;
		else if(ptext[0] == 0  && ptext[3] == 1 )
 		  NextState <= st_st13;
		rtext <= 'b11011000100;
	  end
	  st_st30: begin
		if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 1 )
 		  NextState <= st_st3;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st13;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st30;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st3;
		else if(ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st3;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0 )
 		  NextState <= st_st13;
		else if(ptext[0] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st13;
		else if(ptext[1] == 0  && ptext[3] == 0  && ptext[4] == 0 )
 		  NextState <= st_st30;
		else if(ptext[2] == 0  && ptext[4] == 0 )
 		  NextState <= st_st30;
		rtext <= 'b11110101111;
	  end
	  st_st31: begin
		if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st32;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0 )
 		  NextState <= st_st31;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st3;
		else if(ptext[0] == 1  && ptext[2] == 1 )
 		  NextState <= st_st3;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st32;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1 )
 		  NextState <= st_st32;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[2] == 0 )
 		  NextState <= st_st31;
		else if(ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st31;
		rtext <= 'b10110101101;
	  end
	  st_st32: begin
		if(ptext[0] == 0  && ptext[2] == 0  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st31;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st13;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[2] == 1  && ptext[4] == 0 )
 		  NextState <= st_st32;
		else if(ptext[1] == 1  && ptext[4] == 0 )
 		  NextState <= st_st31;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 0 )
 		  NextState <= st_st13;
		else if(ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st13;
		else if(ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st32;
		rtext <= 'b10011110110;
	  end
	  st_st33: begin
		if(ptext[0] == 1  && ptext[2] == 0  && ptext[4] == 1 )
 		  NextState <= st_st3;
		else if(ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st34;
		else if(ptext[0] == 1  && ptext[3] == 0 )
 		  NextState <= st_st3;
		else if(ptext[1] == 0 )
 		  NextState <= st_st3;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st34;
		else if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st34;
		rtext <= 'b01101111101;
	  end
	  st_st34: begin
		if(ptext[0] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st33;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st13;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 0 )
 		  NextState <= st_st34;
		else if(ptext[0] == 1  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st33;
		else if(ptext[1] == 0  && ptext[4] == 0 )
 		  NextState <= st_st33;
		else if(ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st13;
		else if(ptext[1] == 1  && ptext[2] == 0  && ptext[4] == 0 )
 		  NextState <= st_st13;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 1 )
 		  NextState <= st_st34;
		else if(ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st34;
		rtext <= 'b11101001001;
	  end
	  st_st35: begin
		if(1)
 		  NextState <= st_st36;
		rtext <= 'b10010100000;
	  end
	  st_st36: begin
		if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0 )
 		  NextState <= st_st35;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 0 )
 		  NextState <= st_st13;
		else if(ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st35;
		else if(ptext[1] == 1 )
 		  NextState <= st_st35;
		else if(ptext[1] == 0  && ptext[2] == 0  && ptext[4] == 0 )
 		  NextState <= st_st13;
		else if(ptext[1] == 0  && ptext[3] == 1 )
 		  NextState <= st_st13;
		rtext <= 'b10000110000;
	  end
	  st_st37: begin
		if(ptext[0] == 0  && ptext[2] == 1  && ptext[3] == 0 )
 		  NextState <= st_st15;
		else if(ptext[0] == 1  && ptext[1] == 0  && ptext[4] == 0 )
 		  NextState <= st_st38;
		else if(ptext[1] == 1  && ptext[2] == 1 )
 		  NextState <= st_st15;
		else if(ptext[4] == 1 )
 		  NextState <= st_st15;
		else if(ptext[1] == 0  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st38;
		else if(ptext[2] == 0  && ptext[4] == 0 )
 		  NextState <= st_st38;
		rtext <= 'b01110111101;
	  end
	  st_st38: begin
		if(ptext[0] == 0  && ptext[1] == 1  && ptext[4] == 1 )
 		  NextState <= st_st9;
		else if(ptext[1] == 0  && ptext[2] == 1  && ptext[3] == 1 )
 		  NextState <= st_st38;
		else if(ptext[0] == 0  && ptext[3] == 0 )
 		  NextState <= st_st9;
		else if(ptext[2] == 0 )
 		  NextState <= st_st9;
		else if(ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st38;
		else if(ptext[0] == 1  && ptext[2] == 1 )
 		  NextState <= st_st38;
		rtext <= 'b11101001011;
	  end
	  st_st39: begin
		if(ptext[0] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st15;
		else if(ptext[1] == 1  && ptext[2] == 1  && ptext[4] == 0 )
 		  NextState <= st_st40;
		else if(ptext[1] == 0  && ptext[3] == 1 )
 		  NextState <= st_st15;
		else if(ptext[2] == 0 )
 		  NextState <= st_st15;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[2] == 1 )
 		  NextState <= st_st40;
		else if(ptext[2] == 1  && ptext[3] == 0 )
 		  NextState <= st_st40;
		rtext <= 'b00111001101;
	  end
	  st_st40: begin
		if(1)
 		  NextState <= st_st9;
		rtext <= 'b00000011001;
	  end
	  st_st41: begin
		if(ptext[1] == 1  && ptext[2] == 1  && ptext[3] == 1  && ptext[4] == 0 )
 		  NextState <= st_st15;
		else if(ptext[0] == 0  && ptext[2] == 0  && ptext[4] == 0 )
 		  NextState <= st_st9;
		else if(ptext[0] == 0  && ptext[1] == 1  && ptext[3] == 1  && ptext[4] == 1 )
 		  NextState <= st_st41;
		else if(ptext[0] == 1  && ptext[3] == 1 )
 		  NextState <= st_st15;
		else if(ptext[0] == 0  && ptext[1] == 0  && ptext[3] == 1 )
 		  NextState <= st_st9;
		else if(ptext[2] == 0  && ptext[3] == 0 )
 		  NextState <= st_st9;
		else if(ptext[2] == 1  && ptext[3] == 0 )
 		  NextState <= st_st41;
		rtext <= 'b01110010000;
	  end
	  st_st42: begin
		if(ptext[1] == 0  && ptext[2] == 0  && ptext[3] == 1 )
 		  NextState <= st_st15;
		else if(ptext[0] == 0  && ptext[3] == 0  && ptext[4] == 1 )
 		  NextState <= st_st9;
		else if(ptext[1] == 0  && ptext[4] == 0 )
 		  NextState <= st_st15;
		else if(ptext[0] == 1 )
 		  NextState <= st_st15;
		else if(ptext[0] == 0  && ptext[2] == 1  && ptext[4] == 1 )
 		  NextState <= st_st9;
		else if(ptext[0] == 0  && ptext[1] == 1 )
 		  NextState <= st_st9;
		rtext <= 'b11100110101;
	  end
      endcase // case ( State )
   end // always @ (State or ptext)   
endmodule // fsm
